;; AcETUtil.lsp
;; TM-CAD Engineering 2002-2005
;;
;; Replacement for original acetutil*.fas used by & for LT-Extender 2000
;;
;; This code is automatically managed by LT-Extender, if the ExpressTools are present
;; This file contains utility functions AND AutoLoad command definitions for ET Vol1-8 & 1-9
;;
;; DO NOT EDIT THIS FILE & DO NOT MANUALLY LOAD THIS FILE UNDER AUTOCAD LT !
;;

;;====== Determine AutoCAD LT Version ========
(setq g_AcadVer (atof (getvar "acadver"))) ;; 2000=15.0, 2001=15.05, 2002=15.06, 2004=16.0, 2005=16.1, 2006=16.2, 2007=17.0

;;====== Detect Version of ExpressTools ======
(setq ET:InstalledVersion 0)  ;; Bit-Mask : 1=Vol1-8 (R2000)  2=Vol1-9 (>R2000i)
(if (or (findfile "acetloc.lsp")  (findfile "isort.lsp"))   (setq ET:InstalledVersion (+ ET:InstalledVersion 1)))  ;; Vol.1-8 : R2000
(if (or (findfile "acetmail.arx") (findfile "acetftp.arx")) (setq ET:InstalledVersion (+ ET:InstalledVersion 2)))  ;; Vol.1-9 : R2000i/2002/2004/2005/2006/2007

;;==== Detect ARX Version of ExpressTools ====
;;(setq ET:InstalledFileVer (getvar "arxversion:acetutil.arx"))  ;; integer  : 1=R15 2=R16 3=R17
(setq ET:InstalledFileVer 0)  ;; integer  : 1=R15 2=R16 3=R17
(cond
 ((findfile "isort.lsp")      (setq ET:InstalledFileVer 1)) ;; Vol.1-8 for Acad 2000-2002
 ((findfile "acethist.arx")   (setq ET:InstalledFileVer 1)) ;; Vol.1-9 for Acad 2000-2002
 ((findfile "fscreen.arx")    (setq ET:InstalledFileVer 2)) ;; Vol.1-9 for Acad 2004-2006
 ((findfile "acetutil.arx")   (setq ET:InstalledFileVer 3)) ;; Vol.1-9 for Acad 2007-
)
(cond   ;;--- check ET File versio vs. Acad file version
 ((<= g_AcadVer 15.99) (if (/= ET:InstalledFileVer 1) (setq ET:InstalledVersion -1)))
 ((<= g_AcadVer 16.99) (if (/= ET:InstalledFileVer 2) (setq ET:InstalledVersion -2)))
 ((<= g_AcadVer 17.99) (if (/= ET:InstalledFileVer 3) (setq ET:InstalledVersion -3)))
)

;;====== AutoLoader Commands Definitions =====
(setq ET$ACETFILESFOUND NIL)
(defun LTEX$AutoLoadET ( )
 (if (not (findfile "AcetUtil.arx")) (alert "* Missing ExpressTools file <AcetUtil.arx> - check support pathes !\n* ExpressTools-Datei <AcetUtil.arx> nicht gefunden - Support-Pfade prfen !\n"))
 ;;------- ET Vol.1-8 (R2000) detected --------
 (if (> (logand ET:InstalledVersion 1) 0)
  (progn
   ;;----- Preload Base ARX ----------
   (arxload "AcetUtil.arx")
   (arxload "RText.arx")
   (arxload "CTextApp.arx")
   (if (not (findfile "acwipeout.arx")) (arxload "wipeout.arx"))
   ;;---------------------------------
   (acet-autoloadarx '("dimsio.arx"   "(C:DIMEX)"       "(command \"_DIMEX\")"))
   (acet-autoloadarx '("dimsio.arx"   "(C:DIMIM)"       "(command \"_DIMIM\")"))
   (acet-autoloadarx '("mocoro.arx"   "(C:MOCORO)"      "(command \"_MOCORO\")"))
   (acet-autoloadarx '("leaderex.arx" "(C:TXT2MTXT)"    "(command \"_TXT2MTXT\")"))
   (acet-autoloadarx '("leaderex.arx" "(C:QLATTACH)"    "(command \"_QLATTACH\")"))
   (acet-autoloadarx '("leaderex.arx" "(C:QLATTACHSET)" "(command \"_QLATTACHSET\")"))
   (acet-autoloadarx '("leaderex.arx" "(C:QLDETACHSET)" "(command \"_QLDETACHSET\")"))
   (acet-autoloadarx '("packngo.arx"  "(C:PACK)"        "(command \"_PACK\")"))
   (acet-autoloadarx '("packngo.arx"  "(C:-PACK)"       "(command \"_-PACK\")"))
   ;;----- ONLY if not built-in ------
   (if (not (findfile "acrevcloud.arx")) (acet-autoload '("revcloud" "(C:REVCLOUD)")))
   ;;---------------------------------
   (acet-autoload '("redir.lsp"    "(C:-REDIRMODE)"))
   (acet-autoload '("xlist.lsp"    "(C:-XLIST)"))
   (acet-autoload '("count.lsp"    "(C:BCOUNT)"))
   (acet-autoload '("trexblk.lsp"  "(C:BEXTEND)"))
   (acet-autoload '("blockq.lsp"   "(C:BLOCK?)"))
   (acet-autoload '("trexblk.lsp"  "(C:BTRIM)"))
   (acet-autoload '("burst.lsp"    "(C:BURST)"))
   (acet-autoload '("clipit.lsp"   "(C:CLIPIT)"))
   (acet-autoload '("julian.lsp"   "(C:DATE)"))
   (acet-autoload '("acetess.lsp"  "(C:EXC)"))
   (acet-autoload '("acetess.lsp"  "(C:EXCP)"))
   (acet-autoload '("acetess.lsp"  "(C:EXF)"))
   (acet-autoload '("acetess.lsp"  "(C:EXP)"))
   (acet-autoload '("acetess.lsp"  "(C:EXW)"))
   (acet-autoload '("acetess.lsp"  "(C:EXWP)"))
   (acet-autoload '("extrim.lsp"   "(C:EXTRIM)"))
   (acet-autoload '("fscreen.lsp"  "(C:FULLSCREEN)"))
   (acet-autoload '("gatte.lsp"    "(C:GATTE)"))
   (acet-autoload '("getsel.lsp"   "(C:GETSEL)"))
   (acet-autoload '("sprhatch.lsp" "(C:IMAGEOVERLAP)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYCUR)"))
   (acet-autoload '("lydelmrg.lsp" "(C:LAYDEL)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYFRZ)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYISO)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYLCK)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYMCH)"))
   (acet-autoload '("lydelmrg.lsp" "(C:LAYMRG)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYOFF)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYON)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYTHW)"))
   (acet-autoload '("acetlayr.lsp" "(C:LAYULK)"))
   (acet-autoload '("lman.lsp"     "(C:LMAN)"))
   (acet-autoload '("lman.lsp"     "(C:-LMAN)"))
   (acet-autoload '("lman.lsp"     "(C:LMANMODE)"))
   (acet-autoload '("lman.lsp"     "(C:-LMANMODE)"))
   (acet-autoload '("mkltype.lsp"  "(C:MKLTYPE)"))
   (acet-autoload '("mkshape.lsp"  "(C:MKSHAPE)"))
   (acet-autoload '("mpedit.lsp"   "(C:MPEDIT)"))
   (acet-autoload '("mstretch.lsp" "(C:MSTRETCH)"))
   (acet-autoload '("trexblk.lsp"  "(C:NCOPY)"))
   (acet-autoload '("pljoin.lsp"   "(C:PLJOIN)"))
   (acet-autoload '("pljoin.lsp"   "(C:PLJOINMODE)"))
   (acet-autoload '("redir.lsp"    "(C:REDIR)"))
   (acet-autoload '("redir.lsp"    "(C:REDIRMODE)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEDIT)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEXT)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEXTAPP)"))
   (acet-autoload '("aceturl.lsp"  "(C:SHOWURLS)"))
   (acet-autoload '("ssx.lsp"      "(C:SSX)"))
   (acet-autoload '("sprhatch.lsp" "(C:SUPERHATCH)"))
   (acet-autoload '("textfit.lsp"  "(C:TEXTFIT)"))
   (acet-autoload '("textmask.lsp" "(C:TEXTMASK)"))
   (acet-autoload '("textmask.lsp" "(C:TEXTUNMASK)"))
   (acet-autoload '("textmask.lsp" "(C:TFHELP)"))
   (acet-autoload '("sprhatch.lsp" "(C:TFRAMES)"))
   (acet-autoload '("txtexp.lsp"   "(C:TXTEXP)"))
   (acet-autoload '("xdata.lsp"    "(C:XDATA)"))
   (acet-autoload '("xdata.lsp"    "(C:XDLIST)"))
   (acet-autoload '("xlist.lsp"    "(C:XLIST)"))
  )
 )
 ;;------- ET Vol.1-9 (R2000i-2007) detected --------
 (if (> (logand ET:InstalledVersion 2) 0)
  (progn
   ;;----- Preload Base ARX ----------
   (arxload "AcetUtil.arx")
   (arxload "RText.arx")
   (arxload "CTextApp.arx")
   (if (not (findfile "acwipeout.arx")) (arxload "wipeout.arx"))
   ;;---------------------------------
   (acet-autoloadarx '("acetdcp.arx"   "(c:dcprops)"     "(command \"_dcprops\")"))
   (acet-autoloadarx '("acetfpth.arx"  "(c:fullpath)"    "(command \"_fullpath\")"))
   (acet-autoloadarx '("dbview.arx"    "(c:dbview)"      "(command \"_dbview\")"))
   (acet-autoloadarx '("dimsio.arx"    "(c:dimsio)"      "(command \"_dimsio\")"))
   (acet-autoloadarx '("edittime.arx"  "(c:edittime)"    "(command \"_edittime\")"))
   (acet-autoloadarx '("fscreen.arx"   "(c:fscreen)"     "(command \"_fscreen\")"))
   (acet-autoloadarx '("laytrans.arx"  "(c:laytrans)"    "(command \"_laytrans\")"))
   (acet-autoloadarx '("laywalk.arx"   "(c:laywalk)"     "(command \"_laywalk\")"))
   (acet-autoloadarx '("leaderex.arx"  "(c:qlattach)"    "(command \"_qlattach\")"))
   (acet-autoloadarx '("leaderex.arx"  "(c:qlattachset)" "(command \"_qlattachset\")"))
   (acet-autoloadarx '("leaderex.arx"  "(c:qldetachset)" "(command \"_qldetachset\")"))
   (acet-autoloadarx '("leaderex.arx"  "(c:txt2mtxt)"    "(command \"_txt2mtxt\")"))
   (acet-autoloadarx '("mocoro.arx"    "(c:mocoro)"      "(command \"_mocoro\")"))
   (acet-autoloadarx '("packngo.arx"   "(c:pack)"        "(command \"_pack\")"))
   (acet-autoloadarx '("propulate.arx" "(c:propulate)"   "(command \"_propulate\")"))
   (acet-autoloadarx '("sysvdlg.arx"   "(c:sysvdlg)"     "(command \"_sysvdlg\")"))
   (acet-autoloadarx '("xpath.arx"     "(c:xpath)"       "(command \"_xpath\")"))
   ;;----- ONLY if not built-in ------
   (if (not (findfile "acrevcloud.arx")) (acet-autoload '("Revcloud.lsp" "(C:REVCLOUD)")))
   ;;---------------------------------
   (acet-autoload '("acadinfo.lsp" "(c:acadinfo)"))
   (acet-autoload '("acadinfo.lsp" "(c:addvars2scr)"))
   (acet-autoload '("acadinfo.lsp" "(c:lspdump)"))
   (acet-autoload '("acadinfo.lsp" "(c:vars2scr)"))
   (acet-autoload '("acetess.lsp"  "(c:exc)"))
   (acet-autoload '("acetess.lsp"  "(c:excp)"))
   (acet-autoload '("acetess.lsp"  "(c:exf)"))
   (acet-autoload '("acetess.lsp"  "(c:exp)"))
   (acet-autoload '("acetess.lsp"  "(c:exw)"))
   (acet-autoload '("acetess.lsp"  "(c:exwp)"))
   (if (< g_AcadVer 17.0)
    (progn
     (acet-autoload '("acetlayr.lsp" "(C:LAYCUR)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYFRZ)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYISO)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYLCK)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYMCH)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYOFF)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYON)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYTHW)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYULK)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYUNISO)"))
     (acet-autoload '("acetlayr.lsp" "(C:LAYVPI)"))
     (acet-autoload '("acetlayr.lsp" "(c:layvpmode)"))
    )
   )
   (acet-autoload '("acettxt.lsp"  "(c:tcircle)"))
   (acet-autoload '("acettxt.lsp"  "(c:tcount)"))
   (acet-autoload '("acettxt.lsp"  "(c:tjust)"))
   (acet-autoload '("acettxt.lsp"  "(c:torient)"))
   (acet-autoload '("aceturl.lsp"  "(C:CHURLS)"))
   (acet-autoload '("aceturl.lsp"  "(C:REPURLS)"))
   (acet-autoload '("aceturl.lsp"  "(c:showurls)"))
   (acet-autoload '("aliasedit.lsp" "(C:ALIASEDIT)"))
   (acet-autoload '("aspace.lsp"   "(c:alignspace)"))
   (acet-autoload '("attout.lsp"   "(c:attin)"))
   (acet-autoload '("attout.lsp"   "(c:attout)"))
   (acet-autoload '("blockq.lsp"   "(c:block?)"))
   (acet-autoload '("blocktoxref.lsp" "(c:blockreplace)"))
   (acet-autoload '("blocktoxref.lsp" "(c:-blockreplace)"))
   (acet-autoload '("blocktoxref.lsp" "(c:blocktoxref)"))
   (acet-autoload '("blocktoxref.lsp" "(c:-blocktoxref)"))
   (acet-autoload '("breakl.lsp"   "(c:breakline)"))
   (acet-autoload '("burst.lsp"    "(C:BURST)"))
   (acet-autoload '("cdorder.lsp"  "(c:cdorder)"))
   (acet-autoload '("cdorder.lsp"  "(c:-cdorder)"))
   (acet-autoload '("chspace.lsp"  "(c:chspace)"))
   (acet-autoload '("clipit.lsp"   "(c:clipit)"))
   (acet-autoload '("closeall.lsp" "(C:CLOSEALL)"))
   (acet-autoload '("copym.lsp"    "(c:copym)"))
   (acet-autoload '("copyto.lsp"   "(c:copytolayer)"))
   (acet-autoload '("copyto.lsp"   "(c:-copytolayer)"))
   (acet-autoload '("count.lsp"    "(c:bcount)"))
   (acet-autoload '("dimassoc.lsp" "(c:dimreassoc)"))
   (acet-autoload '("exfillet.lsp" "(c:exfillet)"))
   (acet-autoload '("exoffset.lsp" "(c:exOffset)"))
   (acet-autoload '("explan.lsp"   "(c:explan)"))
   (acet-autoload '("extrim.lsp"   "(c:extrim)"))
   (acet-autoload '("fastsel.lsp"  "(c:fastsel)"))
   (acet-autoload '("fastsel.lsp"  "(c:fs)"))
   (acet-autoload '("fastsel.lsp"  "(c:fsmode)"))
   (acet-autoload '("flatten.lsp"  "(c:flatten)"))
   (acet-autoload '("fscreen.lsp"  "(c:fullscreen)"))
   (acet-autoload '("gatte.lsp"    "(C:gatte)"))
   (acet-autoload '("getsel.lsp"   "(c:GETSEL)"))
   (acet-autoload '("history.lsp"  "(C:HISTORY)"))
   (acet-autoload '("history.lsp"  "(C:HISTORYFILE)"))
   (acet-autoload '("ix_edit.lsp"  "(c:imageapp)"))
   (acet-autoload '("ix_edit.lsp"  "(c:imageedit)"))
   (acet-autoload '("julian.lsp"   "(c:date)"))
   (acet-autoload '("layoutmerge.lsp" "(c:layoutmerge)"))
   (acet-autoload '("layoutmerge.lsp" "(c:-layoutmerge)"))
   (acet-autoload '("lman.lsp"     "(c:lman)"))
   (acet-autoload '("lman.lsp"     "(c:-lman)"))
   (acet-autoload '("lman.lsp"     "(c:lmanmode)"))
   (acet-autoload '("lman.lsp"     "(c:-lmanmode)"))
   (acet-autoload '("lspdata.lsp"  "(c:lsp)"))
   (acet-autoload '("lspsurf.lsp"  "(C:LSPSURF)"))
   (acet-autoload '("lydelmrg.lsp" "(C:LAYDEL)"))
   (acet-autoload '("lydelmrg.lsp" "(C:LAYMRG)"))
   (acet-autoload '("mkltype.lsp"  "(c:mkltype)"))
   (acet-autoload '("mkshape.lsp"  "(c:mkshape)"))
   (acet-autoload '("movebak.lsp"  "(C:MOVEBAK)"))
   (acet-autoload '("mpedit.lsp"   "(c:mpedit)"))
   (acet-autoload '("mstretch.lsp" "(c:mstretch)"))
   (acet-autoload '("overkill.lsp" "(c:overkill)"))
   (acet-autoload '("overkill.lsp" "(c:-overkill)"))
   (acet-autoload '("pljoin.lsp"   "(c:pljoin)"))
   (acet-autoload '("pljoin.lsp"   "(c:pljoinmode)"))
   (acet-autoload '("plt2dwg.lsp"  "(c:plt2dwg)"))
   (acet-autoload '("redir.lsp"    "(c:redir)"))
   (acet-autoload '("redir.lsp"    "(c:redirmode)"))
   (acet-autoload '("redir.lsp"    "(c:-redirmode)"))
   (acet-autoload '("revert.lsp"   "(C:REVERT)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEDIT)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEXT)"))
   (acet-autoload '("rtext.lsp"    "(C:RTEXTAPP)"))
   (acet-autoload '("rtucs.lsp"    "(c:rtucs)"))
   (acet-autoload '("shp2blk.lsp"  "(c:shp2blk)"))
   (acet-autoload '("sprhatch.lsp" "(c:imageoverlap)"))
   (acet-autoload '("sprhatch.lsp" "(c:Superhatch)"))
   (acet-autoload '("sprhatch.lsp" "(c:tframes)"))
   (acet-autoload '("ssx.lsp"      "(c:ssx)"))
   (acet-autoload '("tcase.lsp"    "(c:tcase)"))
   (acet-autoload '("tcase.lsp"    "(c:-tcase)"))
   (acet-autoload '("tedit.lsp"    "(C:TEDIT)"))
   (acet-autoload '("textfit.lsp"  "(c:textfit)"))
   (acet-autoload '("textfit.lsp"  "(c:TFHELP)"))
   (acet-autoload '("textmask.lsp" "(c:textmask)"))
   (acet-autoload '("textmask.lsp" "(c:textunmask)"))
   (acet-autoload '("trex.lsp"     "(c:trex)"))
   (acet-autoload '("trexblk.lsp"  "(c:bextend)"))
   (acet-autoload '("trexblk.lsp"  "(c:btrim)"))
   (acet-autoload '("trexblk.lsp"  "(c:ncopy)"))
   (acet-autoload '("txtexp.lsp"   "(c:txtexp)"))
   (acet-autoload '("vpscale.lsp"  "(c:vpscale)"))
   (acet-autoload '("vpsync.lsp"   "(c:vpsync)"))
   (acet-autoload '("xdata.lsp"    "(c:xdata)"))
   (acet-autoload '("xdata.lsp"    "(C:XDLIST)"))
   (acet-autoload '("xlist.lsp"    "(c:xlist)"))
   (acet-autoload '("xlist.lsp"    "(c:-xlist)"))
   (acet-autoload '("attout.lsp"   "(bns_get_att lst)"))
   (acet-autoload '("attout.lsp"   "(acet-insert-attrib-get lst)"))
   (acet-autoload '("tblname.lsp"  "(acet-dict-filter-match tblname flt)"))
   (acet-autoload '("tblname.lsp"  "(acet-is-symbol-table str)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-check-flags tblname flags flt)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-format tblname)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get alst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-cmd alst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-cmd-list msg lst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-dlg alst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-ename tblname name)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-is-valid name tblname flags flt lst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-item-list tblname flags flt)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-get-pickit alst)"))
   (acet-autoload '("tblname.lsp"  "(acet-ui-table-name-object-data tblname e1 gcode)"))
   ;;------------- from Lisp programs ----------------
   (acet-autoload '("lman.lsp" "(bns_dl lstate)"))
   (acet-autoload '("lman.lsp" "(bns_rl lstate)"))
   (acet-autoload '("lman.lsp" "(bns_sl lstate)"))
   (acet-autoload '("lman.lsp" "(bns_get_layerstates)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-block-referenced-tables bna tblst)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-block-referenced-tables-ent e1 tblst)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-block-referenced-tables-purge tblst)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-block-replace bna bna2)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-block-to-xref bna fna prg)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-blocktoxref-apply-xref-layer-props lalst origlays laymap)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-blocktoxref-copy-layer-props la la2)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-blocktoxref-local-layer-name xla loclst)"))
   (acet-autoload '("blocktoxrefsup.lsp" "(acet-blocktoxref-local-to-xref-layer-map xrefname)"))
   (acet-autoload '("acet-wmf.lsp"   "(acet-flatn-pline-adjust-widths e1 xv)"))
   (acet-autoload '("acet-wmf.lsp"   "(acet-geom-arc-list-to-pline e1 alst)"))
   (acet-autoload '("acet-wmf.lsp"   "(acet-geom-point-list-to-arc-list lst fuz)"))
   (acet-autoload '("acet-wmf.lsp"   "(acet-wmf-convert alst)"))
   (acet-autoload '("hatchutil.lsp"  "(acet-hatch-boundary-assoc-db e1 lst updateOK)"))
   (acet-autoload '("hatchutil.lsp"  "(acet-hatch-boundary-enames e1)"))
   (acet-autoload '("hatchutil.lsp"  "(acet-hatch-boundary-ss e1)"))
   (acet-autoload '("hatchutil.lsp"  "(acet-hatch-edge-id-remove-all e1)"))
   (acet-autoload '("hatchutil.lsp"  "(acet-hatch-update e1)"))
   (acet-autoload '("flattensup.lsp" "(acet-flatn ss hide)"))
   (acet-autoload '("flattensup.lsp" "(acet-flatn-arc e1)"))
   (acet-autoload '("flattensup.lsp" "(acet-flatn-object-has-thickness e1)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin2 ss st fuzz)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-fuzz-and-mode2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-lwpline-remove-duplicate-pnts2 e1)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-1st-pass2 ss flt)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-2nd-pass2 ss fuzz st flt)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-calc-new-bulge2 p1 b p2 p3)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-do-join2 fuzz st na p1 na2 p2 lst3 tmpe1 tmpe2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-do-ss-pre-work2 ss flt)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-fillet-mod-epoint2 e1 flag x)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-fillet-with-fuzz2 fuzz na p1 tmpe1 na2 p2 tmpe2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-best-int2 a lst)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-closest2 p1 lst fuzz g flst)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-closest-int2 p1 p2 lst)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-epoints2 na)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-fuzz-and-mode2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-matched-pairs2 lst lst5 fuzz g st tmpe1 tmpe2 flst)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-get-width2 na)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-init-mode2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoinmode2)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-mod-tmp2 na p1 tmpe1)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-round2 ss g)"))
   (acet-autoload '("pljoinsup.lsp" "(acet-pljoin-ss-flt2 ss flt)"))
   (acet-autoload '("overkillsup.lsp" "(acet-overkill2 alst)"))
   (acet-autoload '("overkillsup.lsp" "(acet-overkill-gen-prop-get2 e1 genprops)"))
   (acet-autoload '("overkillsup.lsp" "(acet-overkill-line-data2 e1 fuz genprops)"))
   (acet-autoload '("overkillsup.lsp" "(acet-overkill-resolve-arcs2 lst ss2 fuz no-partial no-endtoend)"))
   (acet-autoload '("overkillsup.lsp" "(acet-overkill-ss->primitives2 ss fuz ignore)"))
   (acet-autoload '("overkillsup.lsp" "(acet-rtos2 val)"))
   (acet-autoload '("clipit.lsp"   "(c_clipit na lst)"))
   (acet-autoload '("clipit.lsp"   "(wipeout_clipit na lst)"))
   (acet-autoload '("ddins2.lsp"   "(ddins2)"))
   (acet-autoload '("tcasesup.lsp" "(acet-mtext-format-apply str flst)"))
   (acet-autoload '("tcasesup.lsp" "(acet-mtext-format-extract str)"))
   (acet-autoload '("tcasesup.lsp" "(acet-tcase-change-string a mode)"))
   (acet-autoload '("mkshape.lsp"  "(bns_get_shapefile shapename)"))
   (acet-autoload '("rtext.lsp"    "(AcetRText:edit ent)"))
   (acet-autoload '("aspace.lsp"   "(alignspace p1 p2 p3 p4)"))
   (acet-autoload '("yes_no.lsp"   "(bns_get_yes_no lst size)"))
  )
 )
 (princ)
)

;;======= Global Command for ET Menu =========
(if (or (findfile "acetmain.mnc") (findfile "acetmain.mns") (findfile "acetmain.mnu") (findfile "acetmain.cui"))
 (defun c:ExpressMenu ( / menufile )
  (setvar "cmdecho" 0)
  (setvar "nomutt"  1)
  (setq menufile NIL)
  (if (not menufile) (setq menufile (findfile "acetmain.mnc")))
  (if (not menufile) (setq menufile (findfile "acetmain.mns")))
  (if (not menufile) (setq menufile (findfile "acetmain.mnu")))
  (if (not menufile) (setq menufile (findfile "acetmain.cui")))
  (if menufile
   (progn
    (if (not (menugroup "EXPRESS")) (command "_.menuload" menufile))
    (menucmd "p16=+Express.pop1")
   )
  )
  (setvar "cmdecho" 1)
  (setvar "nomutt"  0)
  (princ)
 )
)
;;------ Load ExpressTools Menu -------
(if (> (logand ET:InstalledVersion 3) 0)  ;; 1
 (if (not (menugroup "EXPRESS")) (if c:ExpressMenu (c:ExpressMenu)))
)

;;====== Global Error Handler Function =======
(setq ET$OldErrorHandler NIL)
(defun ET$ErrorHandler ( msg / )

 (setvar "cmdecho" 0)
 ;;;(while (not (equal (getvar "cmdnames") "")) (command))

 (if msg (princ (strcat "* " msg)))
 (acet-ui-progress-done)

 (if ET$UndoFlag
  (progn
   (setvar "cmdecho" 0)
   (command "_.undo" "_end")
   (if ET$UndoCode
    (eval ET$UndoCode)
    (command "_.u")
   )
  )
 )
 (while ET$OldSysVars
  (setq sysvar (car ET$OldSysVars) ET$OldSysVars (cdr ET$OldSysVars))
  (setq sysval (car ET$OldSysVars) ET$OldSysVars (cdr ET$OldSysVars))
  (if (and sysvar sysval) (setvar sysvar sysval))
 )
 (setq ET$OldSysVars NIL ET$SysVars NIL ET$UndoFlag NIL ET$UndoCode NIL)

 (if ET$OldErrorHandler (setq *error* ET$OldErrorHandler))

 (setvar "highlight" 1)
 (setvar "cmdecho" 1)
 (princ)
)
;;====== Global Data for Error Handling ======
(setq ET$OldSysVars NIL ET$SysVars NIL ET$UndoFlag NIL ET$UndoCode NIL)

;;Error Init for ET
(defun acet-error-init ( errlist / syslist sysvar sysval )

 (setq ET$OldErrorHandler *error* *error* ET$ErrorHandler)
 (setq *error* '((MSG /) (ET$ErrorHandler msg)))

 (setq ET$OldSysVars NIL)   ;; previous sysvar values for Restore
 (acet-ui-progress-done)

 (setq ET$SysVars  (car errlist) errlist (cdr errlist))
 (setq ET$UndoFlag (car errlist) errlist (cdr errlist))
 (setq ET$UndoCode (car errlist) errlist (cdr errlist))

 (setq ET$OldSysVars NIL)
 (setq ET$OldSysVars (cons (getvar "ucsicon") ET$OldSysVars))
 (setq ET$OldSysVars (cons "ucsicon" ET$OldSysVars))
 (setq syslist ET$SysVars)

 (while syslist
  (setq sysvar (car syslist) syslist (cdr syslist))
  (setq sysval (car syslist) syslist (cdr syslist))
  (if (and sysvar sysval)
   (progn
    (setq ET$OldSysVars (cons (getvar sysvar) ET$OldSysVars))
    (setq ET$OldSysVars (cons sysvar ET$OldSysVars))
    (setvar sysvar sysval)
   )
  )
 )

 (setvar "cmdecho" 0)
 (if ET$UndoFlag (command "_.undo" "_begin"))

 ET$OldSysVars
)

;;Error Restore for ET
(defun acet-error-restore ( / sysvar sysval )
 (acet-ui-progress-done)
 (if ET$UndoFlag
  (progn
   (setvar "cmdecho" 0)
   (command "_.undo" "_end")
  )
 )
 (while ET$OldSysVars
  (setq sysvar (car ET$OldSysVars) ET$OldSysVars (cdr ET$OldSysVars))
  (setq sysval (car ET$OldSysVars) ET$OldSysVars (cdr ET$OldSysVars))
  (if (and sysvar sysval) (setvar sysvar sysval))
 )
 (setq ET$OldSysVars NIL ET$SysVars NIL ET$UndoFlag NIL ET$UndoCode NIL)

 (if ET$OldErrorHandler (setq *error* ET$OldErrorHandler))

 (setvar "highlight" 1)
 (setvar "cmdecho" 1)
 (princ)
)

;;====== Global Data for Sysvar Handling =====
(setq ET$SavedSysVars NIL)
;;Save Sysvar List
(defun acet-sysvar-set ( varlist / sysvar sysval )
 (setq ET$SavedSysVars nil)
 (while varlist
  (setq varlist (car syslist) varlist (cdr varlist))
  (setq varlist (car syslist) varlist (cdr varlist))
  (if (and sysvar sysval)
   (progn
    (setq ET$SavedSysVars (cons (getvar sysvar) ET$SavedSysVars))
    (setq ET$SavedSysVars (cons sysvar ET$SavedSysVars))
    (setvar sysvar sysval)
   )
  )
 )
 ET$SavedSysVars
)
;;Restore Sysvar List
(defun acet-sysvar-restore ( / sysvar sysval )
 (while ET$SavedSysVars
  (setq sysvar (car ET$SavedSysVars) ET$SavedSysVars (cdr ET$SavedSysVars))
  (setq sysval (car ET$SavedSysVars) ET$SavedSysVars (cdr ET$SavedSysVars))
  (if (and sysvar sysval) (setvar sysvar sysval))
 )
 (princ)
)

;;====== Global Data for Spinner Tool ========
(setq ET$ShowSpinnerStep NIL)
;;Show Spinner Sign
(defun acet-spinner ( / )
 (if (not ET$ShowSpinnerStep) (setq ET$ShowSpinnerStep 0))
 (if (< ET$ShowSpinnerStep 0) (setq ET$ShowSpinnerStep 4))
 (princ (nth ET$ShowSpinnerStep '("\-" "\\\" "\|" "\/" "\ ")))
 (setq ET$ShowSpinnerStep (Rem (1+ ET$ShowSpinnerStep) 4))
 (princ)
)

;;====== Global Data for Table List ==========
;;Get Table Entries
(defun acet-table-name-list ( tblORlist / tblentries tblname flag70 entry entryname entryflag )
 (setq tblname NIL flag70 NIL tblentries NIL)
 (if (and tblORlist (= (type tblORlist) 'STR)) (setq tblname tblORlist))
 (if (and tblORlist (= (type tblORlist) 'LIST))
  (progn
   (setq tblname (car tblORlist) tblORlist (cdr tblORlist))
   (while tblORlist
    (if (not flag70) (setq flag70 0))
    (setq flag70 (+ flag70 (car tblORlist)) tblORlist (cdr tblORlist))
   )
  )
 )
 (if tblname
  (progn
   (setq entry (tblnext tblname T))
   (while entry
    (setq entryname (strcase (cdr (assoc 2 entry))))
    (if (and flag70 (> flag70 0))
     (if (= (logand flag70 (cdr (assoc 70 entry))) flag70)
      (setq tblentries (cons entryname tblentries))
     )
     (setq tblentries (cons entryname tblentries))
    )
    (setq entry (tblnext tblname))
   )
  )
 )
 (reverse tblentries)
)
;;Purge table entry
(defun acet-table-purge ( table entry flag / )
 (if (and table entry)
  (progn
   (command "_.-purge" (strcat "_" table) entry)
   (while (wcmatch (getvar "cmdnames") "*PURGE*") (command "_y"))
  )
 )
 T
)

;;====== Global Data for Setvar/Getvar =======
;;Store custom data 2 Registry
(defun acet::store2reg ( varname varval / regkey txtentry txtkey txtdata )
 (setq varname (strcase varname))
 (setq regkey (strcat "HKEY_CURRENT_USER\\" (vlax-product-key) "\\Profiles\\" (getvar "CPROFILE") "\\General"))
 (cond
  ((= (type varval) 'STR)  (setq txtdata (strcat "STR__" varval)))
  ((= (type varval) 'INT)  (setq txtdata (strcat "INT__" (itoa varval))))
  ((= (type varval) 'REAL) (setq txtdata (strcat "REAL_" (rtos varval 2 8))))
  (T  (setq txtdata ""))
 )
 (vl-registry-write regkey varname txtdata)
 (princ)
)
;;Load custom from Registry
(defun acet::loadreg ( varname / varval regkey txtentry txtkey txtdata )
 (setq varname (strcase varname) varval NIL)
 (setq regkey (strcat "HKEY_CURRENT_USER\\" (vlax-product-key) "\\Profiles\\" (getvar "CPROFILE") "\\General"))
 (setq txtentry (vl-registry-read regkey varname))
 (if (and txtentry (>= (strlen txtentry) 6))
  (progn
   (setq txtkey (strcase (substr txtentry 1 5)) txtdata (substr txtentry 6))
   (cond
    ((= txtkey "STR__") (setq varval txtdata))
    ((= txtkey "INT__") (setq varval (atoi txtdata)))
    ((= txtkey "REAL_") (setq varval (atof txtdata)))
   )
  )
 )
 varval
)
;;Store custom data 2 Dict
(defun acet::store2dict ( varname varval / maindict bnsdict elist xname dictentry )
 (setq varname (strcase varname))
 (setq maindict (namedobjdict))
 (setq bnsdict (dictsearch maindict "BNS_VARIABLES"))
 ;;--- create missing dictionary
 (if bnsdict
  (setq bnsdict (cdr (assoc -1 bnsdict)))
  (progn
   (setq elist (list '(0 . "DICTIONARY") '(100 . "AcDbDictionary")))
   (setq xname (entmakex elist))
   (setq bnsdict (dictadd maindict "BNS_VARIABLES" xname))
  )
 )
 ;;--- Remove old data
 (dictremove bnsdict varname)
 (cond
  ((= (type varval) 'STR)  (setq elist (list '(0 . "XRECORD") '(100 . "AcDbXrecord") (cons 1  varval))))
  ((= (type varval) 'INT)  (setq elist (list '(0 . "XRECORD") '(100 . "AcDbXrecord") (cons 70 varval))))
  ((= (type varval) 'REAL) (setq elist (list '(0 . "XRECORD") '(100 . "AcDbXrecord") (cons 40 varval))))
  (T (setq elist NIL xname NIL))
 )
 (if elist (setq xname (entmakex elist)))
 (if xname (setq xname (dictadd bnsdict varname xname)))
 (princ)
)
;;Load custom from Dict
(defun acet::loaddict ( varname / maindict bnsdict elist entry varval )
 (setq varname (strcase varname) varval NIL)
 (setq maindict (namedobjdict))
 (setq bnsdict (dictsearch maindict "BNS_VARIABLES"))
 (if bnsdict (setq bnsdict (cdr (assoc -1 bnsdict))))
 ;;--- create missing dictionary
 (if (and bnsdict (setq elist (dictsearch bnsdict varname)))
  (progn
   (setq entry (assoc 1  elist))  ;; str
   (if (not entry) (setq entry (assoc 40 elist)))  ;; real
   (if (not entry) (setq entry (assoc 70 elist)))  ;; int
   (if entry (setq varval (cdr entry)))
  )
 )
 varval
)
;;Setvar CmdEcho
(defun acet-set-CmdEcho ( val )
 (if (not val) (setq val 1))
 (if (/= val 1) (setq val 0))
 (setvar "CMDECHO" val)
)
;;Setvar Custom Var
(defun acet-setvar ( varlist / varname varval savemode entry )
 (while varlist
  (setq varname  (car varlist) varlist (cdr varlist))
  (setq varval   (car varlist) varlist (cdr varlist))
  (setq savemode (car varlist) varlist (cdr varlist))
  (if varname
   (progn
    ;;Save to Dictionary
    (if (= (logand savemode 1) 1) (acet::store2dict varname varval))
    ;;Save to Registry
    (if (= (logand savemode 2) 2) (acet::store2reg  varname varval))
   )
  )
 )
 (princ)
)
(defun acet-getvar ( varlist / varname varval savemode entry )
 (setq varval NIL savemode NIL)
 (if varlist
  (progn
   (setq varname  (car varlist) varlist (cdr varlist))
   (setq savemode (car varlist) varlist (cdr varlist))
   (if (not savemode) (setq savemode 3))
   (if varname
    (progn
     ;;Load from Dictionary
     (if (not varval)
      (if (= (logand savemode 1) 1) (setq varval (acet::loaddict varname)))
     )
     ;;Load from Registry
     (if (not varval)
      (if (= (logand savemode 2) 2) (setq varval (acet::loadreg varname)))
     )
    )
   )
  )
 )
 varval
)
;;Create Anonymous Group
(defun acet-group-make-anon ( enamelist desc / en )
 (if enamelist
  (progn
   (command "_.group" "_create" "*")
   (if desc (command desc) (command ""))
   (foreach en enamelist (command en))
   (command "")
  )
 )
 T
)

;;====== Global Data for Ucs -> Object =======
;;Setvar UCS to Ent
(defun acet-ucs-to-object ( ent / elist zvec p10 p11 pb pc ang )
 (setq elist NIL)
 (if ent (setq elist (entget ent)))
 (if elist
  (progn
   (setq p10 (cdr (assoc 10 elist)) zvec (cdr (assoc 210 elist)))
   (if p10
    (progn
     (setq ang 0.0 p11 (cdr (assoc 11 elist)))
     (if p11 (setq ang (angle (list 0.0 0.0 0.0) p11)))
     (setq pb (polar p10 ang 1.0))
     (setq pc (polar p10 (+ ang 1.57) 1.0))  ;; ZVEC besser !!!
     (command "_.ucs" "_3p" p10 pb pc)
    )
   )
  )
 )
 (princ)
)
;;Setvar UCS to Ent
(defun acet-ucs-set-z ( zvec / zv )
  (setq zv "*0.0,0.0,1.0")
  (if zvec
   (setq zv
    (strcat "*"
      (rtos (car zvec) 2 8) ","
      (rtos (cadr zvec) 2 8) ","
      (rtos (caddr zvec) 2 8)
    )
   )
  )
 (command "_.ucs" "_za" "*0.0,0.0,0.0" zv)
 (princ)
)
;;get current/entity ucs
(defun acet-ucs-get ( from / retucs ucsentry )
 (setq retucs (list (getvar "ucsorg") (getvar "ucsxdir") (getvar "ucsydir")))
;(if (and from (= (type from) 'ENAME)) ; not used by ET !
; (if (setq ucsentry (assoc 210 (entget from))) (setq retucs (cdr ucsentry)))
;)
 retucs
)
(defun acet-ucs-set ( ucs / )
 (command "_.ucs" "_3p")
 (if (car ucs) (command (car ucs)))
 (if (cadr ucs) (command (cadr ucs)))
 (if (caddr ucs) (command (caddr ucs)))
 (princ)
)
;;execute ucs command
(defun acet-ucs-cmd ( cmdlist / sCmd )
 (command "_.ucs")
 (foreach sCmd cmdlist (command sCmd))
 (princ)
)
;;Set XData Values for keys
(defun acet-xdata-set ( xkeylist / retval ename appid xdata elist xlist :get_xlist )
 (defun :get_xlist ( ename appid / elist )
  (setq elist NIL)
  (if (and ename appid) (setq elist (entget ename (list appid))))
  (setq elist (cdr (assoc -3 elist)))
  (setq elist (car elist))  ;; extract list
  (setq elist (cdr elist))  ;; remove APPID
  elist
 )
 (defun :modify_xentry ( xlist setdata / retlist datakey dataval dxfkey entry newentry IsFound oldkey olddata )
  (setq retlist NIL)
  (setq datakey (car setdata) setdata (cdr setdata))
  (setq dataval (car setdata) setdata (cdr setdata))
  (setq dxfkey  (car setdata) setdata (cdr setdata))
  (if (= (type datakey) 'STR) (setq datakey (strcase datakey)))

  (setq IsFound NIL oldkey NIL olddata NIL)
  (while xlist
   (setq entry (car xlist) xlist (cdr xlist))
   (if (and (= (car entry) 1002) (= (cdr entry) "{"))
    (progn
     (setq oldkey  (car xlist) xlist (cdr xlist)) ;; key
     (setq olddata (car xlist) xlist (cdr xlist)) ;; data
     (setq xlist   (cdr xlist))                   ;; "}"
     (if (and oldkey olddata)
      (if (= (strcase (cdr oldkey)) datakey)
       (progn
        (setq IsFound T)
        (if dataval
         (setq retlist (append retlist (list (cons 1002 "{")(cons 1000 datakey)(cons dxfkey dataval)(cons 1002 "}"))))
        )
       )
       (setq retlist (append retlist (list (cons 1002 "{") oldkey olddata (cons 1002 "}"))))
      )
     )
    )
   )
  )
  ;;add new data entry
  (if (and (not IsFound) dataval)
   (setq retlist (append retlist (list (cons 1002 "{")(cons 1000 datakey)(cons dxfkey dataval)(cons 1002 "}"))))
  )
  retlist
 )

 ;;-----
 (setq retval NIL elist NIL xlist NIL)

 (setq ename (car xkeylist) xkeylist (cdr xkeylist))
 (setq appid (car xkeylist) xkeylist (cdr xkeylist))
 (setq xdata (car xkeylist) xkeylist (cdr xkeylist))
 (regapp appid)

 ;;get xdata entries only
 (if (and ename appid) (setq xlist (:get_xlist ename appid)))

 ;;modify each xdata entry
 (foreach entry xdata
  (setq xlist (:modify_xentry xlist entry))
 )

 ;;add XData Appid ID
 (if xlist (setq retval (cons appid xlist)))
 (setq xlist (list -3 (cons appid xlist)))

 (if ename (setq elist (entget ename)))
 (if elist (setq elist (append elist (list xlist))))

 (if elist (entmod elist))
 retval
)
;;Get XData Value for key
(defun acet-xdata-get ( xkeylist / ename appid datakey elist xlist entry key retval )
 (setq retval NIL)
 (setq ename   (car xkeylist) xkeylist (cdr xkeylist))
 (setq appid   (car xkeylist) xkeylist (cdr xkeylist))
 (setq datakey (car xkeylist) xkeylist (cdr xkeylist))

 (if (and ename appid datakey)
  (progn
   (if (= (type datakey) 'STR) (setq datakey (strcase datakey)))
   (setq elist (entget ename (list appid)))
   (setq xlist (cdr (assoc -3 elist)))
   (setq xlist (car xlist))  ;; extract list
   (setq xlist (cdr xlist))  ;; remove APPID
   (while (and (not retval) (setq entry (car xlist)))
    (setq xlist (cdr xlist))
    (if (and (= (car entry) 1002) (= (cdr entry) "{"))
     (progn
      (setq entry (car xlist) xlist (cdr xlist))    ;; is Key
      (if (and (= (car entry) 1000) (= (strcase (cdr entry)) datakey))
       (setq entry (car xlist) retval (cdr entry)) ;; is Value
      )
     )
    )
   )
  )
 )
 retval
)
;;Get XData Value for key
(defun bns_ss_mod ( ss flag pr / retss ssidx sslen ename elist bChkLayer elayer bChkSpace espace bChkMesh etype eflag bAddEntity currspace )
 (setq retss (ssadd))
 (setq sslen 0.0 ssidx 0.0 bChkLayer NIL bChkSpace NIL)
 (if (and ss (= (type ss) 'PICKSET)) (setq sslen (sslength ss)))

 (if (> (logand flag 1) 0) (setq bChkLayer T)) ;;(bns_ss_mod SS 1 T) ;filter out the locked layers
 (if (> (logand flag 2) 0) (setq bChkSpace T)) ;;(bns_ss_mod SS 3 T) ;remove all that are not in current space or on locked
 (if (> (logand flag 4) 0) (setq bChkMesh  T)) ;;(bns_ss_mod SS 7 T) ;remove PolyMeshes

 (setq currspace (getvar "CVPORT"))
 (if (> currspace 1) (setq currspace 0) (setq currspace 1)) ; 0=model 1=paper

 (while (< ssidx sslen)
  (setq ename (ssname ss ssidx) elist NIL)
  (if ename (setq elist (entget ename)))
  (if elist
   (progn
    (setq bAddEntity T)
    (if (and bAddEntity bChkLayer)  ; Flag|1, removed entities on locked Layers
     (progn
      (setq elayer (cdr (assoc 8 elist)))
      (if (acet-layer-locked elayer) (setq bAddEntity NIL))
     )
    )
    (if (and bAddEntity bChkSpace)  ; Flag|2, remove entities from other space
     (progn
      (setq espace (cdr (assoc 67 elist)))
      (if (not espace) (setq espace 0))  ;; Defaults to Modelspace=0
      (if (/= espace currspace) (setq bAddEntity NIL))
     )
    )
    (if (and bAddEntity bChkMesh)  ; Flag|4, remove PolyMeshes
     (progn
      (setq etype (cdr (assoc 0 elist)))
      (if (and etype (= (strcase etype) "POLYLINE"))
       (progn
        (setq eflag (cdr (assoc 70 elist)))
        (if (not eflag) (setq eflag 0))  ;; Defaults to 0
        (if (> (logand eflag 112) 0) (setq bAddEntity NIL))
       )
      )
     )
    )
    ;;Add Entity
    (if bAddEntity (ssadd ename retss))
   )
  )

  (setq ssidx (+ ssidx 1.0))
 )
 (if (<= (sslength retss) 0.0) (setq retss NIL))
 (list retss 0 0 0)
)
;;====== Global Data for Layer Locked ? ======
;;Check Layer Locked ?
(defun acet-layer-locked ( layer / elist isLocked )
 (setq isLocked NIL)
 (if (and layer (setq elist (tblsearch "LAYER" layer)))
  (if (= (logand (cdr (assoc 70 elist)) 4) 4) (setq isLocked T))
 )
 isLocked
)
;;Unlock all layers
(defun acet-layer-unlock-all ( / lockedlayers entry layer flag70 )
 (setq lockedlayers NIL)
 (command "'_-layer")
 (setq entry (tblnext "LAYER" T))
 (while entry
  (setq layer (cdr (assoc 2 entry)) flag70 (cdr (assoc 70 entry)))
  (if (= (logand flag70 4) 4)
   (progn
    (command "_unlock" layer)
    (if (not lockedlayers)
     (setq lockedlayers layer)
     (setq lockedlayers (strcat lockedlayers "," layer))
    )
   )
  )
  (setq entry (tblnext "LAYER"))
 )
 (command "")
 lockedlayers
)
;;rebuild polylines
(defun acet-plines-rebuild ( plist / ss idx enames ename elist etype ltgen ispoly entry sewlst sw ew spoint oldicon lastent wentry swlst ewlst blglst )
 (setq ss NIL idx 1 oldicon (getvar "ucsicon"))
 (setvar "ucsicon" 0)
 (acet-ui-progress-init "Rebuilding plines" (length plst))
 (while (setq entry (car plist))
  (acet-ui-progress-safe idx)
  (setq plist (cdr plist))
  (setq lastent (entlast))
  (setq ltgen (nth 0 entry) enames (nth 1 entry) sewlst (nth 2 entry) ucs (nth 3 entry) spoint (nth 4 entry))
  (setq swlst NIL ewlst NL blglst NIL)
  (foreach wentry sewlst
   (setq swlst (cons (car wentry) swlst)
         ewlst (cons (cadr wentry) ewlst)
         blglst (cons 0.0 blglst)
   )
  )
  (setq swlst (reverse swlst) ewlst (reverse ewlst) blglst (reverse blglst))

  (setq ename (car enames) enames (cdr enames))
  (if (setq elist (entget ename))
   (progn
    (setq etype (strcase (cdr (assoc 0 elist))))
    (if (or (= etype "POLYLINE") (= etype "LWPOLYLINE")) (setq ispoly T) (setq ispoly NIL))
    (command "_ucs" "_object" ename)
    (command "_pedit" ename)
    (if (not ispoly) (command "_y"))
    (command "_join")
    (foreach ename enames (command ename))
    (command "" "_ltype" ltgen "")
    (command "_ucs" "_p")
    (if (/= (entlast) lastent)
     (progn
      (setq lastent (entlast))
      ;--- apply width ---
      (acet::apply_width_bulge lastent swlst ewlst blglst)
      (if (not ss)
       (setq ss (ssadd lastent))
       (ssadd lastent ss)
      )
     )
    )
   )
  )
  (setq idx (1+ idx))
 )
 (acet-ui-progress-done)

 (setvar "ucsicon" oldicon)
 ss
)
;;re-apply pline segment width
(defun acet-pline-segment-list-apply ( na lst / mainname ename elist etype ptlist swlst ewlst blglst newelist entry sw ew )
 (setq ptlst (car lst) swlst (cadr lst) ewlst (caddr lst) blglst (cadddr lst))
 (acet::apply_width_bulge na swlst ewlst blglst)
 T
)
(defun acet::apply_width_bulge ( na swlst ewlst blglst / mainname ename elist etype ptlist swlst ewlst blglst newelist entry gw sw ew )
 (if (= (type na) 'LIST)
  (setq elist na ename (cdr (assoc -1 elist)))
  (setq ename na elist (entget ename))
 )
 (setq mainname ename etype (strcase (cdr (assoc 0 elist))))
 (setq newelist NIL gw NIL sw NIL ew NIL)

 (if (= (length swlst) 1) ;;global width
  (setq gw (car swlst))
 )
 (if (= etype "LWPOLYLINE")
  (foreach entry elist
   (cond
    ((= (car entry) 10)
     (setq sw (car swlst) swlst (cdr swlst) ew (car ewlst) ewlst (cdr ewlst))
     (if (not sw) (setq sw gw))
     (if (not ew) (setq ew gw))
    )
    ((= (car entry) 40) (if sw (setq entry (cons 40 sw))))
    ((= (car entry) 41) (if ew (setq entry (cons 41 ew))))
    ((= (car entry) 43) (if gw (setq entry (cons 43 gw))))
   )
   (if entry (setq newelist (cons entry newelist)))
  )
 )
 (if (= etype "POLYLINE")
  (progn
   (if gw
    (progn
     (if (setq entry (assoc 40 elist))
      (setq elist (subst (cons 40 gw) entry elist))
      (setq elist (append elist (list (cons 40 gw))))
     )
     (if (setq entry (assoc 41 elist))
      (setq elist (subst (cons 41 gw) entry elist))
      (setq elist (append elist (list (cons 41 gw))))
     )
     (entmod elist)
    )
   )
   (while (and ename (setq ename (entnext ename)))
    (if (setq elist (entget ename) etype (cdr (assoc 0 elist)))
     (cond
      ((= (strcase etype) "SEQEND") (setq ename NIL))
      ((= (strcase etype) "VERTEX")
       (progn
        (setq sw (car swlst) swlst (cdr swlst) ew (car ewlst) ewlst (cdr ewlst))
        (if (not sw) (setq sw gw))
        (if (not ew) (setq ew gw))
        (if sw
         (if (setq entry (assoc 40 elist))
          (setq elist (subst (cons 40 sw) entry elist))
          (setq elist (append elist (list (cons 40 sw))))
         )
        )
        (if ew
         (if (setq entry (assoc 41 elist))
          (setq elist (subst (cons 41 ew) entry elist))
          (setq elist (append elist (list (cons 41 ew))))
         )
        )
        (entmod elist)
       )
      )
     )
    )
   )
  )
 )
 (if newelist (entmod (reverse newelist)))
 (entupd mainname)
 T
)
;;explode polylines
(defun acet-plines-explode ( ss / idx retss cltypegen retenames widthlist ename elist etype eucs estartp estartz eflag eelev flag1 flag2 newdata newdatalist )
 (setq retss NIL newdatalist NIL idx 0)
 (if (and ss (= (type ss) 'PICKSET))
  (progn
   (acet-ui-progress-init "Gathering line and arc data from plines" (sslength ss))
   (while (setq ename (ssname ss idx))
    (acet-ui-progress-safe idx)
    (setq cltypegen "_off" retenames NIL etype NIL widthlist (list 0.0 0.0) eucs (list 0.0 0.0 1.0))
    (setq estartp (list 0.0 0.0 0.0) eflag 0 eelev 0.0 flag1 NIL flag2 NIL)
    (if (setq elist (entget ename))
     (progn
      (setq etype (strcase (cdr (assoc 0 elist))))
      (if (or (= etype "POLYLINE") (= etype "LWPOLYLINE"))
       (progn
        (if (assoc  10 elist) (setq estartp (cdr (assoc  10 elist))))
        (if (assoc 210 elist) (setq eucs    (cdr (assoc 210 elist))))
        (if (assoc  70 elist) (setq eflag   (cdr (assoc  70 elist))))
        (if (assoc  38 elist) (setq eelev   (cdr (assoc  38 elist))))
        (if (> (logand eflag 128) 0) (setq cltypegen "_on"))

        (setq estartz 0.0)
        (if (caddr estartp) (setq estartz (caddr estartp)))
        (setq estartp (list (car estartp) (cadr estartp) (+ estartz eelev)))

        (setq widthlist (acet::plines-get-widthlist ename etype elist))
        (if (setq retenames (acet::pline-explode ename))
         (foreach ename retenames
          (if retss (ssadd ename retss) (setq retss (ssadd ename)))
         )
        )
        (setq newdata (list cltypegen retenames widthlist eucs estartp flag1 flag2))
        (setq newdatalist (cons newdata newdatalist))
       )
       (progn
        (if retss (ssadd ename retss) (setq retss (ssadd ename)))
       )
      )
     )
    )
    (setq idx (1+ idx))
   )
   (acet-ui-progress-done)
  )
 )
 (list retss (reverse newdatalist))
)
;get pline segment data
(defun acet-pline-segment-list ( elist / ename etype plist widthlist swlist ewlist blglist swidth ewidth entry )
 (setq ename (cdr (assoc -1 elist)) etype (cdr (assoc 0 elist)))
 (setq plist (acet-geom-object-point-list ename NIL) swlist NIL ewlist NIL)
 (setq widthlist (acet::plines-get-widthlist ename etype elist))
 (setq swidth 0.0 ewidth 0.0)
 (foreach entry plist
  (if (setq entry (car widthlist))
   (progn
    (setq widthlist (cdr widthlist))
    (setq swidth (car entry) ewidth (cadr entry))
   )
  )
  (setq swlist (cons swidth swlist) ewlist (cons ewidth ewlist) blglist (cons 0.0 blglist))
 )
 (if (not swlist)  (setq swlist  (list 0.0)))
 (if (not ewlist)  (setq ewlist  (list 0.0)))
 (if (not blglist) (setq blglist (list 0.0)))
 (list plist (reverse swlist) (reverse ewlist) (reverse blglist))
)
(defun acet::plines-get-widthlist ( ename etype elist / widthlist entry subtype subval swidth ewidth nextname nextlist nexttype flag subswidth subewidth widthentry )
 (setq widthlist NIL)
 (if (= etype "LWPOLYLINE")
  (while (setq entry (car elist))
   (setq elist (cdr elist))
   (setq subtype (car entry) subval (cdr entry))
   (if (= subtype 40) (setq subswidth subval))
   (if (= subtype 41)
    (progn
     (setq subewidth subval)
     (if (and subswidth subewidth)
      (progn
       (setq widthentry (list subswidth subewidth))
       (if (not (equal widthentry (last widthlist)))
        (setq widthlist (append widthlist (list widthentry)))
       )
      )
     )
    )
   )
  )
 )
 (if (= etype "POLYLINE")
  (progn
   (setq swidth 0.0 ewidth 0.0)
   (if (assoc 40 elist) (setq swidth (cdr (assoc 40 elist))))
   (if (assoc 41 elist) (setq ewidth (cdr (assoc 41 elist))))

   (setq nexttype NIL nextlist NIL)
   (if (setq nextname (entnext ename)) (setq nextlist (entget nextname)))
   (if nextlist (setq nexttype (strcase (cdr (assoc 0 nextlist)))))

   (while (and nexttype (= nexttype "VERTEX"))
    (setq flag (cdr (assoc 70 nextlist)))
    (if (= (logand flag 17) 0)  ;; no helper/frame vertexes
     (progn
      (setq subswidth NIL subewidth NIL)
      (if (assoc 40 elist) (setq subswidth (cdr (assoc 40 elist))))
      (if (assoc 41 elist) (setq subewidth (cdr (assoc 41 elist))))
      (if (and subswidth subewidth)
       (progn
        (setq widthentry (list subswidth subewidth))
        (if (not (equal widthentry (last widthlist)))
         (setq widthlist (append widthlist (list widthentry)))
        )
       )
      )
     )
    )
    (setq nexttype NIL nextlist NIL)
    (if (setq nextname (entnext nextname)) (setq nextlist (entget nextname)))
    (if nextlist (setq nexttype (strcase (cdr (assoc 0 nextlist)))))
   )
   (if (not widthlist) (setq widthlist (list (list swidth ewidth))))
  )
 )
 (if (not widthlist) (setq widthlist (list (list 0.0 0.0))))
 widthlist
)
(defun acet::pline-explode ( ename / lastename retenames svar )
 (setq retenames NIL lastename (entlast))
 (command "_.ucs" "_object" ename)
 (command "_.pedit" ename "_width" 0.0 "")
 (command "_.explode" ename)
 (command "_.ucs" "_previous")
 (setq svar (getvar "cmdnames"))
 (if (wcmatch svar "*EXPLODE*") (command ""))
 (while (setq lastename (entnext lastename)) (setq retenames (cons lastename retenames)))
 retenames
)

;;====== Global Data for Selection Sets ======
;;filter selection set
(defun acet-ss-ssget-filter ( ss flt / retss ename elist idx )
 (setq retss NIL idx 0)
 (while (and ss (setq ename (ssname ss idx)))
  (if (setq elist (entget ename))
   (if (bns_filter_match elist flt)
    (if (not retss) (setq retss (ssadd ename)) (ssadd ename retss))
   )
  )
  (setq idx (+ idx 1))
 )
 retss
)
;;Create new SelectionSet with Ent
(defun acet-ss-new ( ename / retss elist )
 (setq retss (ssadd))
 (if ename
  (setq ename (entnext ename))
  (setq ename (entnext))
 )
 (while ename
  (setq elist (entget ename))
  (if (and (not (equal "VERTEX" (cdr (assoc 0 elist))))
        (not (equal "SEQEND" (cdr (assoc 0 elist))))
      )
   (ssadd ename retss)
  )
  (setq ename (entnext ename))
 )
 retss
)
;;Clear previous SelectionSet
(defun acet-ss-clear-prev ( / ss )
 (if (entnext)
  (progn
   (if (entmake (list (cons 0 "POINT")(cons 10 (list 0.0 0.0 0.0))))
    (progn
     (command "_.select" (entlast) "")
     (entdel (entlast))
    )
    (progn
     (command "_.undo" "_begin")
     (command "_.select" (entlast) (entnext) "")
     (command "_.undo" "_end")
     (command "_.undo" 1)
    )
   )
  )
 )
 (princ)
)
;;Make Entities Visible(0)-Invisible(1)
(defun acet-ss-visible ( entset flag / ename elist n )
 (setq n 0)
 (if entset
  (repeat (sslength entset)
   (setq ename (ssname entset n) elist (entget ename))
   (if (not (assoc 60 elist))
    (setq elist (append elist (list (cons 60 flag))))
    (setq elist (subst (cons 60 flag) (assoc 60 elist) elist))
   )
   (entmod elist)
   (entupd ename)
   (setq n (1+ n))
  )
 )
)
;;SelectionSet Intersection
(defun acet-ss-intersection ( ss ssmaster / retss ename ssidx )
 (setq retss NIL)
 (if (and ss ssmaster)
  (progn
   (setq ssidx 0.0 retss (ssadd))
   (while (setq ename (ssname ss ssidx))
    (if (ssmemb ename ssmaster) (ssadd ename retss))
    (setq ssidx (+ ssidx 1.0))
   )
   (if (= (sslength retss) 0) (setq retss NIL))
  )
 )
 retss
)
;;Filter Selection Set
(defun acet-ss-filter ( filterdata / retss ss filter flag xfilter entry ssvalid ssnew ssidx ename msg1 msgn )
 (setq ss (nth 0 filterdata) filter (nth 1 filterdata) flag (nth 2 filterdata))
 (setq retss ss)
 (foreach entry filter
  (if (= (type (car entry)) 'LIST)
   (progn
    (setq xfilter (nth 0 entry) msg1 (nth 1 entry) msgn (nth 2 entry))
    (setq ssvalid (ssget "X" xfilter))
    (if flag
     (progn
      (setq ssnew (ssadd) ssidx 0 nrfail 0)
      (while (setq ename (ssname retss ssidx))
       (if (ssmemb ename ssvalid)
        (ssadd ename ssnew)
        (setq nrfail (1+ nrfail))
       )
       (setq ssidx (1+ ssidx))
      )
      (cond
       ((and msg1 (= nrfail 1)) (princ msg1))
       ((and msgn (> nrfail 1)) (princ (acet-str-format msgn nrfail)))
      )
      (setq retss ssnew ssnew NIL)
     )
    )
    (setq ssvalid NIL)
   )
  )
 )
 (if (<= (sslength retss) 0) (setq retss NIL))
 (list retss (list (list (list "CURRENTSPACE") 0 "")))
)
;;Build filter part for current space
(defun acet-ss-flt-cspace ( / space )
 (setq space 0)
 (if (and (= (getvar "tilemode") 0) (<= (getvar "cvport") 1)) (setq space 1))
 (list (cons 410 (getvar "ctab")) (cons 67 space))
)
;;Remove Ents from SelectionSet
(defun acet-ss-remove ( ss ssmaster / retss ename ssidx )
 (setq retss ssmaster)
 (if (and ss retss)
  (progn
   (setq ssidx 0.0)
   (while (setq ename (ssname ss ssidx))
    (if (ssmemb ename retss) (setq retss (ssdel ename retss)))
    (setq ssidx (+ ssidx 1.0))
   )
  )
 )
 retss
)
;;Combine SelectionSets together
(defun acet-ss-union ( sslist / retss ss ename ssidx )
 (setq retss (ssadd))
 (while (setq ss (car sslist))
  (setq sslist (cdr sslist) ssidx 0.0)
  (while (setq ename (ssname ss ssidx))
   (if (entget ename) (ssadd ename retss))
   (setq ssidx (+ ssidx 1.0))
  )
 )
 retss
)
;;Redraw SelectionSet with Mode
(defun acet-ss-redraw ( ss mode / ename ssidx )
 (if (not mode) (setq mode 1))
 (setq ssidx 0.0)
 (while (setq ename (ssname ss ssidx))
  (redraw ename mode)
  (setq ssidx (+ ssidx 1.0))
 )
 (princ)
)
;;Redraw SelectionSet with Mode
(defun acet-list-m-assoc ( key datalist / retlist entry )
 (setq retlist NIL)
 (while datalist
  (setq entry (car datalist))
  (if (or (= key (car entry)) (eq key (car entry)) (equal key (car entry) 0.001))
   (setq retlist (cons entry retlist))
  )
  (setq datalist (cdr datalist))
 )
 (reverse retlist)
)
;;Entdel ss entities
(defun acet-ss-entdel ( ss / idx )
 (setq idx 0.0)
 (if ss
  (while (setq ename (ssname ss idx))
   (if (entupd ename) (entdel ename))
   (setq idx (+ idx 1.0))
  )
 )
 idx
)
;;filter entities on current ucs
(defun acet-ss-filter-current-ucs ( ss printit / retss idx failed ename ucs eucs )
 (setq retss (ssadd) idx 0 failed 0)
 (setq ucs (acet-geom-cross-product (getvar "ucsxdir") (getvar "ucsydir")))
 (if ss
  (while (setq ename (ssname ss idx))
   (if (setq eucs (cdr (assoc 210 (entget ename))))
    (if (> (distance ucs eucs) 0.001)
     (setq failed (1+ failed))
     (ssadd ename retss)
    )
   )
   (setq idx (1+ idx))
  )
 )
 (if (and printit (> failed 0)) (prompt (strcat "\n" (itoa failed) " object(s) were not parallel to the current ucs.\n")))
 (if (= (sslength retss) 0) (setq retss NIL))
 retss
)
(defun acet-ss-annotation-filter ( ss / ) ss)
;;Get Attributes into ss, remove inserts
(defun bns_annotation_ss ( ss / retss idx ename elist etype )
 (setq retss (ssadd) idx 0)
 (if ss
  (while (setq ename (ssname ss idx))
   (setq elist (entget ename) etype (strcase (cdr (assoc 0 elist))))
   (if (/= etype "INSERT")
    (ssadd ename retss)
    (if (> (cdr (assoc 66 elist)) 0)
     (while (and ename (setq ename (entnext ename)))
      (setq elist (entget ename) etype (strcase (cdr (assoc 0 elist))))
      (if (= etype "ATTRIB")
       (ssadd ename retss)
       (setq ename NIL)
      )
     )
    )
   )
   (setq idx (+ idx 1))
  )
 )
 retss
)
;;Convert selection-set to entities list
(defun acet-ss-to-list ( ss / lst ssidx )
 (setq lst NIL ssidx 0.0)
 (if ss
  (while (setq ename (ssname ss ssidx))
   (setq lst (cons ename lst))
   (setq ssidx (+ ssidx 1.0))
  )
 )
 lst
)
;;Convert entities list to selection-set
(defun acet-list-to-ss ( lst / retss ename )
 (setq retss (ssadd))
 (while (setq ename (car lst))
  (setq lst (cdr lst))
  (ssadd ename retss)
 )
 retss
)
;####### Punkte p1/p2 von entry ohne Z-Wert !!!
(defun acet-ss-zoom-extents ( ss / ssidx ename p1 p2 pmid xmin xmax ymin ymax zmin zmax z z1 z2 )
 (setq ptext (acet-geom-ss-extents ss NIL))
 (setq p1 (car ptext) p2 (cdar ptext))
 (setq xmin (car p1) ymin (cadr p1) zmin (caddr p1))
 (setq xmax (car p2) ymax (cadr p2) zmax (caddr p2))

 (setq pmid (acet-geom-mid-point p1 p2))
 (setq p1 (acet-geom-point-scale p1 pmid 1.05))
 (setq p2 (acet-geom-point-scale p2 pmid 1.05))
 (setq z (/ (+ zmin zmax) 2.0))

 (command "_.zoom" "_window" p1 p2)
 (list (list xmin ymin z) (list xmax ymax z))
)
;;Remove duplicate entities
(defun acet-ss-remove-dups ( ss fuz ignore / ssremoved idx key ename etype geomext geomctr p1 p2 elist plist params pentry1 pentry2 parlist datalist fuz2 )
 (setq ssremoved NIL datalist NIL idx 0.0)
 (setq parlist NIL)
 (if (not (member   6 ignore)) (setq parlist (cons   6 parlist)))
 (if (not (member   8 ignore)) (setq parlist (cons   8 parlist)))
 (if (not (member  39 ignore)) (setq parlist (cons  39 parlist)))
 (if (not (member  62 ignore)) (setq parlist (cons  62 parlist)))
 (if (not (member 370 ignore)) (setq parlist (cons 370 parlist)))
 (if (not (member 390 ignore)) (setq parlist (cons 390 parlist)))

 (if (not fuz) (setq fuz 0.0) (setq fuz (abs fuz)))
 (setq fuz2 (* 2.0 fuz))

 (acet-ui-progress-init "Searching for duplicate objects - Pass I" (sslength ss))
 (setq idx 0.0)
 (while (setq ename (ssname ss idx))
  (acet-ui-progress-safe (fix idx))
  (setq elist (entget ename) etype (cdr (assoc 0 elist)))
  (setq geomctr (list 0.0 0.0))
  (if (setq geomext (acet-ent-geomextents ename))
   (if (and (setq p1 (car geomext)) (setq p2 (cadr geomext)))
    (setq geomctr (list (* 0.5 (+ (car p1) (car p2))) (* 0.5 (+ (cadr p1) (cadr p2)))))
   )
  )
  (setq params NIL)
  (foreach key parlist
   (setq params (cons (cdr (assoc key elist)) params))
  )
  (setq params (cons etype params))
  (setq datalist (cons (list params geomctr (acet-geom-object-point-list ename NIL) ename) datalist))

  (setq idx (+ idx 1.0))
 )
 (acet-ui-progress-done)

 (setq ssremoved (ssadd))

 (acet-ui-progress-init "Searching for duplicate objects - Pass II" (sslength ss))
 (setq idx 0.0)
 (while (setq pentry1 (car datalist))
  (acet-ui-progress-safe (fix idx))
  (setq datalist (cdr datalist))
  (setq params (car pentry1) geomctr (cadr pentry1) plist (caddr pentry1))
  ;--- test with rest ---
  (foreach pentry2 datalist
   (if (equal params (car pentry2))
    (if (equal geomctr (cadr pentry2) fuz)
     (if (acet::check-identic-points plist (caddr pentry2) fuz)
      (progn
       (ssdel (cadddr pentry2) ss)
       (ssadd (cadddr pentry2) ssremoved)
      )
     )
    )
   )
  )
  (setq idx (+ idx 1.0))
 )
 (acet-ui-progress-done)
 (if (= (sslength ss)        0) (setq ss        NIL))
 (if (= (sslength ssremoved) 0) (setq ssremoved NIL))
 (list ss ssremoved)
)
(defun acet::check-identic-points ( plist1 plist2 fuz / stop )
 (setq stop T)
 (if (and plist1 plist2)
  (if (= (length plist1) (length plist2))
   (progn
    (setq stop NIL)
    (while (and (not stop) plist1 plist2)
     (if (not (equal (car plist1) (car plist2) fuz))
      (setq stop T)
      (setq plist1 (cdr plist1) plist2 (cdr plist2))
     )
    )
   )
  )
 )
 (not stop)
)
;;get text justification
(defun acet-tjust-keyword ( elist / just flag72 flag73 )
 (setq just "" flag72 0 flag73 0) ; defaults
 (if (assoc 72 elist) (setq flag72 (cdr (assoc 72 elist))))
 (if (assoc 73 elist) (setq flag73 (cdr (assoc 73 elist))))
 (cond
  ((= flag73 0) ;base
   (cond
    ((= flag72 0) (setq just "START"));=left
    ((= flag72 1) (setq just "CENTER"))
    ((= flag72 2) (setq just "RIGHT"))
    ((= flag72 3) (setq just "ALIGNED")) ;aligned - not suported !!
    ((= flag72 4) (setq just "MIDDLE"))
    ((= flag72 5) (setq just "FIT"))     ;fitted - not supported !!
   )
  )
  ((= flag73 1) ;bottom
   (cond
    ((= flag72 0) (setq just "BL"))
    ((= flag72 1) (setq just "BC"))
    ((= flag72 2) (setq just "BR"))
   )
  )
  ((= flag73 2) ;mid
   (cond
    ((= flag72 0) (setq just "ML"))
    ((= flag72 1) (setq just "MC"))
    ((= flag72 2) (setq just "MR"))
   )
  )
  ((= flag73 3) ;top
   (cond
    ((= flag72 0) (setq just "TL"))
    ((= flag72 1) (setq just "TC"))
    ((= flag72 2) (setq just "TR"))
   )
  )
 )
 just
)
;;(acet-tjust (ssadd na (ssadd)) "Start") ;; then set it to start
(defun acet-tjust ( ss tjust / nmod idx ename elist flag72 flag73 orgbox newbox p10 p11 )
 (setq tjust (strcase tjust) idx 0)
 (if ss
  (while (setq ename (ssname ss idx))
   (if (setq elist (entget ename))
    (progn
     (setq oldjust (strcase (acet-tjust-keyword elist)))
     (if (/= tjust oldjust)
      (progn
       (setq orgbox (acet-geom-textbox elist 0.0))
       (setq flag72 NIL flag73 NIL)
       (cond
        ((= tjust "LEFT")   (setq flag72 0 flag73 0))
        ((= tjust "START")  (setq flag72 0 flag73 0))
        ((= tjust "MIDDLE") (setq flag72 4 flag73 0))
        ((= tjust "RIGHT")  (setq flag72 2 flag73 0))
        ((= tjust "ALIGNED")(setq flag72 3 flag73 0))
        ((= tjust "CENTER") (setq flag72 1 flag73 0))
        ((= tjust "FIT")    (setq flag72 5 flag73 0))
        ((= tjust "BL")     (setq flag72 0 flag73 1))
        ((= tjust "BC")     (setq flag72 1 flag73 1))
        ((= tjust "BR")     (setq flag72 2 flag73 1))
        ((= tjust "ML")     (setq flag72 0 flag73 2))
        ((= tjust "MC")     (setq flag72 1 flag73 2))
        ((= tjust "MR")     (setq flag72 2 flag73 2))
        ((= tjust "TL")     (setq flag72 0 flag73 3))
        ((= tjust "TC")     (setq flag72 1 flag73 3))
        ((= tjust "TR")     (setq flag72 2 flag73 3))
       )
       (if (and flag72 flag73)
        (progn
         (if (setq entry (assoc 72 elist)) (setq elist (subst (cons 72 flag72) entry elist)) (setq elist (append elist (list (cons 72 flag72)))))
         (if (setq entry (assoc 73 elist)) (setq elist (subst (cons 73 flag73) entry elist)) (setq elist (append elist (list (cons 73 flag73)))))
         (entmod elist)
         (setq elist (entget ename))
         (setq newbox (acet-geom-textbox elist 0.0))
         (setq vdiff (acet-geom-delta-vector (car newbox) (car orgbox)))
         (setq p10 (cdr (assoc 10 elist)) p11 (cdr (assoc 11 elist)))
         (setq elist (subst (cons 10 (acet-geom-vector-add p10 vdiff)) (assoc 10 elist) elist))
         (if p11
          (setq elist (subst (cons 11 (acet-geom-vector-add p11 vdiff)) (assoc 11 elist) elist))
         )
         (entmod elist)
         (entupd ename)
        )
       )
      )
     )
    )
   )
   (setq idx (1+ idx))
  )
 )
 idx
)
;dummy for missing ET function
(defun acet-insert-attrib-set ( na attlst flag / )
  T
)
;get current vport entity
(defun acet-currentviewport-ename ( / retename ss )
 (setq retename NIL)
 (if (= (getvar "tilemode") 0)
  (if (setq ss (ssget "X" (list (cons 0 "VIEWPORT")(cons 410 (getvar "ctab"))(cons 69 (getvar "cvport")))))
   (setq retename (ssname ss 0))
  )
 )
 retename
)
;set vport locked/unlocked
(defun acet-viewport-lock-set ( vpename setlocked / retval elist flag90 isLocked )
 (setq retval NIL)
 (if (setq elist (entget vpename))
  (if (= (strcase (cdr (assoc 0 elist))) "VIEWPORT")
   (progn
    (setq flag90 (cdr (assoc 90 elist)))
    (if (> (logand flag90 16384) 0) (setq isLocked T) (setq isLocked NIL))
    (if (and (not isLocked) setlocked)
     (progn
      (command "_.mview" "_lock" "_on" vpename "")
      (setq retval vpename)
     )
    )
    (if (and isLocked (not setlocked))
     (progn
      (command "_.mview" "_lock" "_off" vpename "")
      (setq retval vpename)
     )
    )
   )
  )
 )
 retval
)

(defun acet-alert ( msg / ) (alert msg))
(defun acet-fscreen-toggle ( / ) T)
(defun acet-init-fas-lib ( flag1 flag2 / ) (princ))

;;===== Global Data for Geometric Calc =======
;;Create anonymous block from ss
(defun acet-block-make-anon ( ss blkname / :rem_group :next-anon-block bna n na e1 )

 (defun :next-anon-block ( / anonname ctr )
  (setq anonname "*U" ctr 1)
  (while (tblsearch "BLOCK" (strcat anonname (itoa ctr)))
   (setq ctr (1+ ctr))
  )
  (strcat anonname (itoa ctr))
 )
 (defun :rem_group ( a e1 / b )
  (while (setq b (assoc a e1))
   (setq e1 (append (reverse (cdr (member b (reverse e1)))) (cdr (member b e1))))
  )
  e1
 )

 (if (not blkname) (setq blkname (:next-anon-block)))
 (entmake nil)
 (setq bna
  (entmake (list '(0 . "BLOCK") (cons 2 blkname) '(10 0.0 0.0 0.0) '(70 . 1) (cons 3 blkname)))
 )

 (setq n 0)
 (repeat (sslength ss)
  (setq  na (ssname ss n)
         e1 (entget na '("*"))
         e1 (:rem_group -1 e1)
         e1 (:rem_group 5 e1)
  )
  (entmake e1)
  (if (equal '(66 . 1) (assoc 66 e1))
   (progn
    (setq na (entnext na)
          e1 (entget na)
          e1 (:rem_group -1 e1)
          e1 (:rem_group 5 e1)
    )
    (while (and na (not (wcmatch (cdr (assoc 0 e1)) "*END*")))
     (entmake e1)
     (setq na (entnext na)
           e1 (entget na)
           e1 (:rem_group -1 e1)
           e1 (:rem_group 5 e1)
     )
    )
    (entmake e1)
   )
  )
  (setq n (1+ n))
 )
 (setq blkname (entmake (list (cons 0 "ENDBLK"))))
 blkname
)
;;Purge Block with given name
(defun acet-block-purge ( bna / )
 (if bna
  (progn
   (command "_.purge" "_block" bna)
   (while (wcmatch (getvar "cmdnames") "*PURGE*") (command "_y"))
  )
 )
 (princ)
)

;;===== Global Data for Geometric Calc =======
(defun getgeomextents ( en / ) (acet-ent-geomextents en))
(defun acet-geom-z-axis ( / )
 (acet-geom-cross-product (getvar "ucsxdir") (getvar "ucsydir"))
)
;;flat point
(defun acet-point-flat ( pt from to / retpt )
 (setq retpt (trans pt from to))
 (list (car pt) (cadr pt) 0.0)
)
;;Calculate Midpoint for P1,P2
(defun acet-geom-midpoint ( p1 p2 / pm x1 x2 y1 y2 z1 z2 )
 (setq pm p1)
 (if (and p1 p2)
  (progn
   (setq x1 (car p1) y1 (cadr p1) z1 (caddr p1))
   (setq x2 (car p2) y2 (cadr p2) z2 (caddr p2))
   (if (and x1 y1 x2 y2) (setq pm (list (/ (+ x1 x2) 2.0) (/ (+ y1 y2) 2.0))))
   (if (and x1 y1 x2 y2 z1 z2) (setq pm (list (/ (+ x1 x2) 2.0) (/ (+ y1 y2) 2.0) (/ (+ z1 z2) 2.0))))
  )
 )
 pm
)
;;Transform Pointlist
(defun acet-geom-m-trans ( pntlst from to / pnt retpntlist )
 (setq retpntlist NIL)
 (foreach pnt pntlst
  (setq retpntlist (cons (trans pnt from to) retpntlist))
 )
 (reverse retpntlist)
)
;;Transform Pointlist
(defun acet-geom-list-extents ( pntlst / a b c d e f n x )
 (setq x (car   pntlst)
       a (car   x)
       b (cadr  x)
       c (caddr x)
       d a e b f c
       n 1
 )
 (repeat (max (- (length pntlst) 1) 0)
  (setq x (nth n pntlst))
  (setq a (min a (car   x))
        b (min b (cadr  x))
        c (min c (caddr x))
        d (max d (car   x))
        e (max e (cadr  x))
        f (max f (caddr x))
  )
  (setq n (1+ n))
 )
 (list (list a b c) (list d e f))
)
;;Get Zoom Points to Include Points
(defun acet-geom-zoom-for-select ( pntlist / pa pb )
 (setq pntlist (acet-geom-m-trans pntlist 1 2))
 (setq pa (acet-geom-list-extents (acet-geom-m-trans (acet-geom-view-points) 1 2)))
 (setq pb (acet-geom-list-extents (append pa pntlist)))
 (if (not (equal pa pb))
  (setq pb (list (trans (car  pb) 2 1)
                 (trans (cadr pb) 2 1)
           )
  )
  (setq pb nil)
 )
 pb
)
;;Get Viewport Corner Points
(defun acet-geom-view-points ( / a b c d x )
 (setq b (getvar "viewsize")
       c (car  (getvar "screensize"))
       d (cadr (getvar "screensize"))
       a (* b (/ c d))
       x (trans (getvar "viewctr") 1 2)
       c (list (- (car  x) (/ a 2.0))
               (- (cadr x) (/ b 2.0))
               0.0
         )
       d (list (+ (car  x) (/ a 2.0))
               (+ (cadr x) (/ b 2.0))
               0.0
         )
       c (trans c 2 1)
       d (trans d 2 1)
 )
 (list c d)
)
;;Get Pixel Size in Dwg Units
(defun acet-geom-pixel-unit ( / viewy scrny )
 (setq viewy (getvar "VIEWSIZE"))            ;; Height of screen in Dwg Units
 (setq scrny (cadr (getvar "SCREENSIZE")))   ;; Height of screen in Pixels
 (/ viewy scrny)
)
;;Get Textbox for any Text
(defun acet-geom-textbox ( txtdata offset / p1 p2 p3 p4 ename etype wdth thgt hght inspt just ang tbox pa pb pihalf )
 (if (not txtdata)
  (prompt "\nError : Invalid Text\n")
  (progn
   (if (= (type txtdata) 'LIST)
    (setq ename (cdr (assoc -1 txtdata)))
    (setq ename txtdata txtdata (entget ename))
   )
   (setq etype (strcase (cdr (assoc 0 txtdata))))
   (if (or (= etype "TEXT") (= etype "ATTDEF") (= etype "ATTRIB"))
    (progn
     (setq thgt (cdr (assoc 40 txtdata)))
     (setq p1   (trans (cdr (assoc 10 txtdata)) ename 0))
     (setq ang  (cdr (assoc 50 txtdata)))
     (setq tbox (textbox txtdata) pa (car tbox) pb (cadr tbox))
     (setq p2 (polar p1 ang (car pb)))
     (setq p3 (polar p2 (+ ang (* PI 0.5)) (cadr pb)))
     (setq p4 (polar p1 (+ ang (* PI 0.5)) (cadr pb)))
    )
   )
   (if (= "MTEXT" (strcase (cdr (assoc 0 txtdata))))
    (progn
     (setq thgt (cdr (assoc 40 txtdata)))
     (setq wdth (cdr (assoc 42 txtdata)))
     (setq hght (cdr (assoc 43 txtdata)))
     (setq ins  (trans (cdr (assoc 10 txtdata)) ename 0))
     (setq just (cdr (assoc 71 txtdata)))
     (setq ang  (cdr (assoc 50 txtdata)))
     (cond
      ((= just 1)
       (setq p1 (polar ins (- ang (* pi 0.5)) hght)) ; lower-left
       (setq p2 (polar p1 ang wdth))                 ; lower-right
       (setq p3 (polar ins ang wdth))                ; upper-right
       (setq p4 ins)                                 ; upper-left
      )
      ((= just 2)
       (setq p3 (polar ins ang (/ wdth 2)))
       (setq p4 (polar ins (+ ang pi) (/ wdth 2)))
       (setq p1 (polar p4 (- ang (* pi 0.5)) hght))
       (setq p2 (polar p1 ang wdth))
      )
      ((= just 3)
       (setq p3 ins)
       (setq p4 (polar ins (+ ang pi) wdth))
       (setq p1 (polar p4 (- ang (* pi 0.5)) hght))
       (setq p2 (polar p1 ang wdth))
      )
      ((= just 4)
       (setq p4 (polar ins (+ ang (* pi 0.5)) (/ hght 2)))
       (setq p3 (polar p4 ang wdth))
       (setq p1 (polar p4 (- ang (* pi 0.5)) hght))
       (setq p2 (polar p1 ang wdth))
      )
      ((= just 5)
       (setq p4 (polar ins (- ang pi) (/ wdth 2)))
       (setq p4 (polar p4 (+ ang (* pi 0.5)) (/ hght 2)))
       (setq p3 (polar p4 ang wdth))
       (setq p1 (polar p4 (- ang (* pi 0.5)) hght))
       (setq p2 (polar p1 ang wdth))
      )
      ((= just 6)
       (setq p3 (polar ins (+ ang (* pi 0.5)) (/ hght 2)))
       (setq p4 (polar p3 (+ ang pi) wdth))
       (setq p1 (polar p4 (- ang (* pi 0.5)) hght))
       (setq p2 (polar p1 ang wdth))
      )
      ((= just 7)
       (setq p1 ins)
       (setq p2 (polar p1 ang wdth))
       (setq p3 (polar p2 (+ ang (* pi 0.5)) hght))
       (setq p4 (polar p1 (+ ang (* pi 0.5)) hght))
      )
      ((= just 8)
       (setq p1 (polar ins (+ ang pi) (/ wdth 2)))
       (setq p2 (polar p1 ang wdth))
       (setq p3 (polar p2 (+ ang (* pi 0.5)) hght))
       (setq p4 (polar p1 (+ ang (* pi 0.5)) hght))
      )
      ((= just 9)
       (setq p2 ins)
       (setq p1 (polar ins (+ ang pi) wdth))
       (setq p3 (polar p2 (+ ang (* pi 0.5)) hght))
       (setq p4 (polar p1 (+ ang (* pi 0.5)) hght))
      )
     )
    )
   )
   (setq p1 (trans p1 0 1))
   (setq p2 (trans p2 0 1))
   (setq p3 (trans p3 0 1))
   (setq p4 (trans p4 0 1))

   (if (/= offset 0.0)
    (progn
     (setq ang (angle p1 p2))
     (setq offset (* thgt offset) pihalf (/ PI 2.0))
     (setq p1 (polar p1 (+ ang PI) offset) p1 (polar p1 (- ang pihalf) offset))
     (setq p2 (polar p2 ang        offset) p2 (polar p2 (- ang pihalf) offset))
     (setq p3 (polar p3 ang        offset) p3 (polar p3 (+ ang pihalf) offset))
     (setq p4 (polar p4 (+ ang PI) offset) p4 (polar p4 (+ ang pihalf) offset))
    )
   )
  )
 )
 (list p1 p2 p3 p4)
)
;;Get 5 Rectangle Points
(defun acet-geom-rect-points ( pa pb / xmin ymin xmax ymax p1 p2 p3 p4 )
 (setq xmin (car  pa))
 (setq ymin (cadr pa))
 (setq xmax (car  pb))
 (setq ymax (cadr pb))
 (setq p1 (list xmin ymin 0.0))
 (setq p2 (list xmax ymin 0.0))
 (setq p3 (list xmax ymax 0.0))
 (setq p4 (list xmin ymax 0.0))
 (list p1 p2 p3 p4 p1)
)
;;Point Check Self-Intersection
(defun acet-geom-self-intersect ( pointlist flag / isectpnt primpoints secpoints p1 p2 pa pb )
 (setq isectpnt NIL primpoints pointlist)
 (while (and (not isectpnt) primpoints)
  (setq p1 (car primpoints) primpoints (cdr primpoints))
  (setq p2 (car primpoints))
  (if (and p1 p2)
   (progn
    (setq secpoints primpoints)
    (while (and (not isectpnt) secpoints)
     (setq pa (car secpoints) secpoints (cdr secpoints))
     (setq pb (car secpoints))
     (if (and pa pb)
      (progn
       (setq isectpnt (inters p1 p2 pa pb T))
       (if isectpnt (if (<= (distance isectpnt p1) 0.005) (setq isectpnt NIL)))
       (if isectpnt (if (<= (distance isectpnt p2) 0.005) (setq isectpnt NIL)))
       (if isectpnt (if (<= (distance isectpnt pa) 0.005) (setq isectpnt NIL)))
       (if isectpnt (if (<= (distance isectpnt pb) 0.005) (setq isectpnt NIL)))
      )
     )
    )
   )
  )
 )
 isectpnt
)
;;get object end points
(defun acet-geom-object-end-points ( ename / plist p1 p2 )
 (setq plist (acet-geom-object-point-list ename NIL))
 (setq p1 (car plist) p2 (last plist))
 (list p1 p2)
)
;;Get Object Points Rasterized
(defun acet-geom-object-point-list ( na alt / a b c d n e1 etype lst ) ;; altitude may be NIL !
 (setq lst NIL e1 (entget na) etype (acet-dxf 0 e1))
 (cond
  ;;MTEXT / TEXT / ATTDEF
  ((or (= etype "MTEXT") (= etype "TEXT") (= etype "ATTDEF"))
   (progn
    (setq lst (acet-geom-m-trans (acet-geom-textbox na 0.2) na 1))
    (setq lst (append lst (list (car lst))))
   )
  )
  ;;POINT
  ((= etype "POINT")
   (setq lst (list (trans (acet-dxf 10 e1) na 1)))
  )
  ;;IMAGE
  ((= etype "IMAGE")
   (setq lst (acet-geom-m-trans (acet-geom-image-bounds na) na 1))
  )
  ;;ELLIPSE / SPLINE
  ((or (= etype "ELLIPSE") (= etype "SPLINE"))
   (setq lst (acet-geom-m-trans (acet::measure-points na 0.1) na 1))
  )
  ;;POLYLINE / LWPOLYLINE
  ((or (= etype "POLYLINE") (= etype "LWPOLYLINE"))
   (setq lst (acet::pl-point-list na alt))
  )
  ;;LINE
  ((= etype "LINE")
   (setq lst (list (trans (acet-dxf 10 e1) na 1) (trans (acet-dxf 11 e1) na 1)))
  )
  ;;ARC / CIRCLE
  ((or (= etype "ARC") (= etype "CIRCLE"))
   (progn
    (setq a (acet-dxf 10 e1)   ;center point
          b (acet-dxf 40 e1)   ;radius
          n (acet-dxf 50 e1)   ;start angle
          c (acet-dxf 51 e1)   ;end angle
    )
    (if (= etype "ARC")
     (if (equal n c 0.0001)
      (progn
       (setq c (+ n (* 2.0 PI) -0.0001))
       (setq e1 (subst (cons 51 c) (assoc 51 e1) e1))
       (entmod e1)
      )
     )
    )
    (if (not n)
     (setq n 0 c (* 2.0 pi))
     (if (> n c) (setq c (+ c (* 2.0 pi))))
    )
    (setq lst (acet::arc-point-list a (polar a n b) (polar a c b) (- c n) alt))
    (setq lst (acet-geom-m-trans lst na 1))
   )
  )
 )
 lst
)
;;Get Polyline/LwPolyline Points
(defun acet::pl-point-list ( na alt / na2 a b c z p1 p2 p3 e1 lst lst2 code n flag entry elev )
 (if (= (type na) 'LIST)
  (setq code (cadr na) na (car na))
  (setq code 1)
 )
 (setq e1 (entget na))
 (if (= 1 (logand 1 (acet-dxf 70 e1))) (setq flag 1) (setq flag nil))
 (setq na2 na)

 (if (= (acet-dxf 0 e1) "POLYLINE")
  (progn
   (setq
    na (entnext na)
    e1 (entget na)
    p1 (acet-dxf 10 e1)
     b (acet-dxf 42 e1)
   )
   (setq z (caddr p1))
   (if (setq entry (assoc 38 e1)) (setq z (+ z (cdr entry))))
   (setq p1 (list (car p1) (cadr p1) z))

   (if (/= 16 (logand 16 (acet-dxf 70 e1)))
    (setq lst (list p1))
    (setq lst nil)
   )
   (setq na (entnext na) e1 (entget na))
   (while (/= "SEQEND" (acet-dxf 0 e1 ))
    (setq p2 (acet-dxf 10 e1))
    (setq p2 (list (car p2) (cadr p2) z))
    (if (/= 16 (logand 16 (acet-dxf 70 e1)))
     (progn
      (if (and b p1 (/= b 0) (not (equal p1 p2)))
       (setq p3  (acet-geom-pline-arc-info p1 p2 b)
             lst (append lst (acet::arc-point-list (car p3) p1 p2 (caddr p3) alt))
       )
       (setq lst (append lst (list p2)))
      )
     )
    )
    (setq  b (acet-dxf 42 e1)
          na (entnext na)
          e1 (entget na)
          p1 p2
    )
   )
   (if flag
    (progn
     (setq p2 (car lst))
     (setq p2 (list (car p2) (cadr p2) z))
     (if (and b p1 (/= b 0) (not (equal p1 p2)))
      (setq  p3 (acet-geom-pline-arc-info p1 p2 b)
            lst (append lst (acet::arc-point-list (car p3) p1 p2 (caddr p3) alt))
      )
      (setq lst (append lst (list p2)))
     )
     (setq flag nil)
    )
   )
  )
 )

 (if (= (acet-dxf 0 e1) "LWPOLYLINE")
  (progn
   (setq z (acet-dxf 38 e1))
   (if (not z) (setq z 0.0))
   (setq lst (member (assoc 10 e1) e1))
   (setq n 0)
   (while lst
    (setq a (car lst) lst (cdr lst))
    (if (= 10 (car a))
     (setq a (cons 10 (append (list (cadr a) (caddr a) z))) lst2 (append lst2 (list a)))
     (if (= 42 (car a)) (setq lst2 (append lst2 (list a))))
    )
    (setq n (+ n 1))
   )

   (setq b (car lst2) lst (list (cdr b)))
   (if flag (setq lst2 (append lst2 (list (car lst2))) flag nil))

   (setq n 1)
   (repeat (- (length lst2) 1)
    (setq a (nth n lst2))
    (if
     (and (= 10 (car a))
          (= 42 (car b))
          (/= 0.0 (cdr b))
          c
          (not (equal (cdr a) (cdr c)))
     )
     (progn
      (setq p3 (acet-geom-pline-arc-info (cdr c) (cdr a) (cdr b))
            lst (append lst (acet::arc-point-list (car p3) (cdr c) (cdr a) (caddr p3) alt))
      )
     )
     (progn
      (if (= 10 (car a)) (setq lst (append lst (list (cdr a)))))
     )
    )
    (setq c b b a)
    (setq n (1+ n ))
   )
   (setq lst2 nil)
  )
 )

 (acet-geom-m-trans lst na code)
)
;;Get Arcus Points
(defun acet::arc-point-list ( p1 p2 p3 ang alt / sa ea lst b c d)
 (setq  b (distance p1 p2)     ;the radius
       sa (angle p1 p2)        ;the start angle
       ea (+ sa ang)           ;the end angle
 )
 (setq d (- ea sa))            ;full delta angle of the arc in radians
 (if (<= d 0.0001) (setq d (* 2.0 PI)))
 (if (not alt)
  (setq c (/ (* 2.0 pi) 9.0))      ;use default resolution
  (setq c (acet::delta-ang b alt)) ;use altitute specified.
 )
 (setq c (* c (/ d (abs d))))  ;delta angle increment of the loop
 (if (< (abs (/ d c)) 4.0) (setq c (/ d 4.0)))  ;at least 4 segments are used
 (repeat (+ (fix (+ (abs (/ d c)) 0.000001)) 1)
  (if (not (equal (polar p1 sa b) (last lst)))
   (setq lst (append lst (list (polar p1 sa b))))
  )
  (setq sa (+ sa c))
 )
 (if (not (equal p3 (last lst))) (setq lst (append lst (list p3))))
 lst
)
;;Get Arcus Infos
;returns the delta angle of an arc with the specified altitude and radius
(defun acet::delta-ang ( r a / c ang)
 (setq c (* 2.0 (sqrt (abs (- (* 2.0 r a) (expt a 2.0))))))
 (setq ang (* 2.0 (atan (/ c 2.0) (- r a))))
 ang
)
;;Get Image Bounds
(defun acet-geom-image-bounds ( na / dxf p1 p2 p3 p4 p5 p6 p7 p8 a b c x y ang e1)
 (setq e1 (entget na)
       p1 (acet-dxf 10 e1) ;insert point
       p2 (acet-dxf 11 e1)
       p3 (acet-dxf 12 e1)
       p4 (acet-dxf 13 e1)
 )
 (setq
      ang (atan (/ (cadr p2) (car p2)))
        x (sqrt (+ (expt (car p2) 2) (expt (cadr p2) 2)))
        y (sqrt (+ (expt (car p3) 2) (expt (cadr p3) 2) ))
        a (* x (car p4))
        b (* y (cadr p4))
        c (list (+ a (car p1)) (+ b (cadr p1)) (caddr p1))
       p5 p1                                  ;lower left
       p6 (list (car c) (cadr p1) (caddr p1)) ;lower right
       p7 c                                   ;upper right
       p8 (list (car p1) (cadr c) (caddr p1)) ;upper left
       p6 (acet-geom-point-rotate p6 p1 ang)
       p7 (acet-geom-point-rotate p7 p1 ang)
       p8 (acet-geom-point-rotate p8 p1 ang)
 )
 (list p5 p6 p7 p8 p5)
)
;;Rotate Point
;Rotate 'pnt' from a base point of 'p1' and through an angle of 'ang' (in radians)
(defun acet-geom-point-rotate ( pnt p1 ang / )
 (polar p1 (+ (angle p1 pnt) ang) (distance p1 pnt))
)
;;Get (LW)Polyline Vertexes
(defun acet-geom-vertex-list ( na / e1 lst lst2 code n flag a z )
 (if (= (type na) 'LIST)
  (setq code (cadr na) na (car na))
  (setq code 1)
 )
 (if (= (type code) 'LIST) (setq code 1))  ;; if na is (entsel)
 (setq e1 (entget na))
 (if (= 1 (logand 1 (acet-dxf 70 e1)))
  (setq flag 1)
  (setq flag nil)
 )
 (if (= (acet-dxf 0 e1) "POLYLINE")
  (progn
   (setq na (entnext na) e1 (entget na))
   (while (/= "SEQEND" (acet-dxf 0 e1))
    (setq lst (append lst (list (trans (acet-dxf 10 e1) na code)))
           na (entnext na)
           e1 (entget na)
    )
   )
  )
  (progn
   (setq lst e1 z (acet-dxf 38 e1))
   (if (not z) (setq z 0.0))
   (setq n 0)
   (repeat (length lst)
    (setq a (nth n lst))
    (if (= (car a) 10)
     (setq  a (cdr a)
            a (list (car a) (cadr a) z)
         lst2 (append lst2 (list (trans a na code)))
     )
    )
    (setq n (1+ n))
   )
   (setq lst lst2 lst2 nil)
  )
 )
 (if (and flag lst) (setq lst (append lst (list (car lst)))))
 lst
)
;;Get Difference Vector
(defun acet-geom-delta-vector ( p1 p2 / dx dy dz z1 z2 )
 (setq dx (- (car  p2) (car  p1)))
 (setq dy (- (cadr p2) (cadr p1)))
 (setq z1 (caddr p1) z2 (caddr p2))
 (if (not z1) (setq z1 0.0))
 (if (not z2) (setq z2 0.0))
 (setq dz (- z2 z1))
 (list dx dy dz)
)
;;Scale Vector with X
(defun acet-geom-vector-scale ( vec scale / vx vy vz )
 (setq vx (car vec) vy (cadr vec) vz (caddr vec))
 (if (not vx) (setq vx 0.0))
 (if (not vy) (setq vy 0.0))
 (if (not vz) (setq vz 0.0))
 (list (* vx scale) (* vy scale) (* vz scale))
)
;;Add 2 Vectors
(defun acet-geom-vector-add ( vec add / vx vy vz ax ay az )
 (setq vx (car vec) vy (cadr vec) vz (caddr vec))
 (if (not vx) (setq vx 0.0))
 (if (not vy) (setq vy 0.0))
 (if (not vz) (setq vz 0.0))
 (setq ax (car add) ay (cadr add) az (caddr add))
 (if (not ax) (setq ax 0.0))
 (if (not ay) (setq ay 0.0))
 (if (not az) (setq az 0.0))
 (list (+ vx ax) (+ vy ay) (+ vz az))
)
;;Get Vector Cross Product (Normal Vector)
(defun acet-geom-cross-product ( v1 v2 / nx ny nz x1 y1 z1 x2 y2 z2 )
 (setq x1 (car v1) y1 (cadr v1) z1 (caddr v1))
 (if (not x1) (setq x1 0.0))
 (if (not y1) (setq y1 0.0))
 (if (not z1) (setq z1 0.0))

 (setq x2 (car v2) y2 (cadr v2) z2 (caddr v2))
 (if (not x2) (setq x2 0.0))
 (if (not y2) (setq y2 0.0))
 (if (not z2) (setq z2 0.0))

 (setq nx (- (* y1 z2) (* z1 y2)))
 (setq ny (- (* z1 x2) (* x1 z2)))
 (setq nz (- (* x1 y2) (* y1 x2)))
 (list nx ny nz)
)
;;Get Vector Normalized
(defun acet-geom-unit-vector ( p1 p2 / vnorm vsize )
 (setq vnorm (acet-geom-delta-vector p1 p2))
 (setq vsize (distance (list 0.0 0.0 0.0) vnorm))
 (if (= vsize 0.0) (setq vsize 1.0))
 (setq vnorm (acet-geom-vector-scale vnorm (/ 1.0 vsize)))
 vnorm
)
;;Transform Angle between Coordsys
(defun acet-geom-angle-trans ( ang from to / vec )
 (setq vec (polar (list 0.0 0.0 0.0) ang 1.0))
 (setq vec (trans vec from to T))
 (angle (list 0.0 0.0 0.0) vec)
)
;;Get Arcus Infos
(defun acet-geom-pline-arc-info ( p1 p2 bulge / a b c r ang s)
 (setq b bulge
       c (distance p1 p2)
       a (abs (/ (* c b) 2.0))
       r (/ (+ (expt (/ c 2.0) 2.0) (expt a 2.0))
            (* 2.0 a)
         )
     ang (* 2.0 (atan (/ c 2.0) (- r a)))
       s (* ang r)
     ang (* ang (/ b (abs b)))
      p3 (polar p1 (angle p1 p2) (/ c 2.0))
      p3 (polar p3 (+ (angle p1 p2) (/ pi 2.0)) (* (- r a) (/ b (abs b))))
 )
 (list p3 r ang s a)
)
;;Check Point inside Band along Ptlist
(defun acet-geom-point-inside ( pt ptlist dist / inside p1 p2 ang angneg ptx pisect )
 (setq inside NIL)
 (while (and ptlist (not inside))
  (setq p1 (car ptlist) ptlist (cdr ptlist) p2 (car ptlist))
  (if (and p1 p2)
   (progn
    (setq ang (angle p1 p2) angneg (- ang 1.5707963268))
    (setq ptx (polar pt angneg dist))
    (if (setq pisect (inters p1 p2 pt ptx T)) (setq inside T))
   )
  )
 )
 inside
)
;;Get Side of Point rel. to Vector
(defun acet-geom-vector-side ( pt pa pb / ptside refang ptang refvec ptvec vnorm )
 (setq refang (angle pa pb))
 (if (< refang 0.0) (setq refang (+ refang PI PI)))
 (setq refvec (acet-geom-delta-vector pa pb))

 (setq ptang  (angle pa pt))
 (if (< ptang  0.0) (setq ptang  (+ ptang  PI PI)))
 (setq ptvec  (acet-geom-delta-vector pa pt))

 (setq vnorm (acet-geom-cross-product refvec ptvec))
 (cond
   ((> (caddr vnorm) 0.0) (setq ptside  1.0))
   ((< (caddr vnorm) 0.0) (setq ptside -1.0))
   ((<= (abs (- ptang refang)) 0.01) (setq ptside 0.0))
 )
 ptside
)
;;Get Intersection Points
(defun acet-geom-intersectwith ( ent1 ent2 flag / isectpoints points1 points2 pointsx p1 p2 pa pb pendless isectpt bExtend1 bExtend2 len )

 (setq isectpoints NIL bExtend1 NIL bExtend2 NIL)
 (setq points1 (acet-geom-object-point-list ent1 NIL))
 (setq points2 (acet-geom-object-point-list ent2 NIL))
 (if (= (logand flag 1) 1) (setq bExtend1 T))
 (if (= (logand flag 2) 2) (setq bExtend2 T))

 (if bExtend1   ;; assume, end & beginnig segment are endless
  (progn
   (setq len (length points1))
   (setq p1 (nth 0 points1))
   (setq p2 (nth 1 points1))
   (setq pa (nth (- len 2) points1))
   (setq pb (nth (- len 1) points1))
   (setq pendless (polar p2 (angle p2 p1) 1.0E10))
   (setq points1 (cons pendless (cdr points1)))
   (setq pendless (polar pa (angle pa pb) 1.0E10))
   (setq points1 (reverse points1))
   (setq points1 (cons pendless (cdr points1)))
   (setq points1 (reverse points1))
  )
 )
 (if bExtend2   ;; assume, end & beginnig segment are endless
  (progn
   (setq len (length points2))
   (setq p1 (nth 0 points2))
   (setq p2 (nth 1 points2))
   (setq pa (nth (- len 2) points2))
   (setq pb (nth (- len 1) points2))
   (setq pendless (polar p2 (angle p2 p1) 1.0E10))
   (setq points2 (cons pendless (cdr points2)))
   (setq pendless (polar pa (angle pa pb) 1.0E10))
   (setq points2 (reverse points2))
   (setq points2 (cons pendless (cdr points2)))
   (setq points2 (reverse points2))
  )
 )

 (while points1
  (setq p1 (car points1) points1 (cdr points1))
  (setq p2 (car points1))
  (if (and p1 p2)
   (progn
    (setq pointsx points2)
    (while pointsx
     (setq pa (car pointsx) pointsx (cdr pointsx))
     (setq pb (car pointsx))
     (if (and pa pb)
      (if (setq isectpt (inters p1 p2 pa pb T))
       (if (not (member isectpt isectpoints)) (setq isectpoints (cons isectpt isectpoints)))
      )
     )
    )
   )
  )
 )
 (reverse isectpoints)
)
;;Get Object points by Measure
(defun acet::measure-points ( object dist / ename elist pnt plist last_object )
 (setq plist NIL last_object (entlast) enamelist NIL)
 (command "_.measure" object dist)
 (setq ename (entnext object))
 (while (and ename (/= ename last_object))
  (setq elist (entget ename))
  (if (= (cdr (assoc 0 elist)) "POINT")
   (setq plist (cons (cdr (assoc 10 elist)) plist)
         enamelist (cons ename enamelist)
   )
  )
  (setq ename (entnext ename))
 )
 (foreach ename enamelist (entdel ename))
 (reverse plist)
)
;;Get Entity's Z normal vector
(defun acet-geom-object-normal-vector ( ename / zvec elist entry )
 (setq zvec (list 0.0 0.0 1.0))
 (if (setq elist (entget ename))
  (if (setq entry (assoc 210 elist)) (setq zvec (cdr entry)))
 )
 zvec
)
(defun acet-geom-point-scale ( targetpnt frompnt scale / retpnt vec )
 (if (not scale) (setq scale 1.0))
 (setq retpnt targetpnt)
 (setq vec (acet-geom-delta-vector frompnt targetpnt))
 (setq vec (acet-geom-vector-scale vec scale))
 (setq retpnt (acet-geom-vector-add frompnt vec))
 retpnt
)
;;Check for parallel vectors
(defun acet-geom-vector-parallel ( v1 v2 / vcross vsize ret )
 (setq ret NIL)
 (setq vcross (acet-geom-cross-product v1 v2))
 (setq vsize (distance (list 0.0 0.0 0.0) vcross))
 (if (< vsize 0.001) (setq ret T))
 ret
)
;;Get Arc center from 3 points
(defun acet-geom-arc-center ( pa pb pc / center v1 v2 p1 p2 vn0 vn1 vn2 tx1 tx2 )
 (setq v1 (acet-geom-delta-vector pa pb))
 (setq v2 (acet-geom-delta-vector pb pc))
 (setq p1 (acet-geom-mid-point pa pb))
 (setq p2 (acet-geom-mid-point pb pc))
 (setq vn0 (acet-geom-cross-product v1 v2))
 (setq vn1 (acet-geom-cross-product v1 vn0))
 (setq vn2 (acet-geom-cross-product v2 vn0))
 (setq tx1 (acet-geom-vector-add p1 vn1))
 (setq tx2 (acet-geom-vector-add p2 vn2))
 (setq center (inters p1 tx1 p2 tx2 NIL))
)
;;Get Entity Z-Axis
(defun acet-geom-object-z-axis ( ename / elist zaxis )
 (setq zaxis NIL)
 (if (setq elist (entget ename)) (setq zaxis (cdr (assoc 210 elist))))
 (if (not zaxis) (setq zaxis (list 0.0 0.0 1.0)))
 zaxis
)
;;Get angle between 2 vectors
(defun acet-geom-vector-d-angle ( v1 v2 / x1 y1 z1 x2 y2 z2 diagon sx sy sz ang scalprod long long1 long2 )
 (setq x1 (nth 0 v1) y1 (nth 1 v1) z1 (nth 2 v1))
 (setq x2 (nth 0 v2) y2 (nth 1 v2) z2 (nth 2 v2))
 (setq long1 (distance '(0.0 0.0 0.0) v1))
 (setq long2 (distance '(0.0 0.0 0.0) v2))

 (if (/= long1 0.0)
  (setq x1 (/ x1 long1) y1 (/ y1 long1) z1 (/ z1 long1) v1 (list x1 y1 z1))
 )
 (if (/= long2 0.0)
  (setq x2 (/ x2 long2) y2 (/ y2 long2) z2 (/ z2 long2) v2 (list x2 y2 z2))
 )
 ; Scalarprodukt
 (setq sx (* x1 x2) sy (* y1 y2) sz (* z1 z2))
 (setq scalprod (+ sx sy sz))
 (setq long (* long1 long2))
 (if (/= long 0.0)
  (setq ang (acet::acos (/ scalprod long)))
  (setq ang 1.570796327)    ; Pi/2 = 90.0 Grad
 )
 ; Korrektur, wenn eigentlich Winkel > 90 Grad ! SCHON IN ACOS-FUNKTION !
 (setq diagon (distance v1 v2))
 (if (= diagon 1.414213562) (setq ang pi))
 (if (= diagon 0.0) (setq ang 0.0))

 ang
)
(defun acet::acos ( inval / retval )
 (cond
  ((and (< inval 1.0) (> inval -1.0))
   (setq retval (* (/ 180 pi) (atan (sqrt (- 1 (expt inval 2))) inval)))
  )
  ((= inval 1.0) (setq retval 0.0))
  ((= inval -1.0) (setq retval 180.0))
  ((or (> inval 1.0) (< inval -1.0)) (setq retval NIL))
  (T)
 )
 (if retval (setq retval (* pi (/ retval 180.0))))     ; in Bogenmass
)

;;Get object fuzz
(defun acet-geom-object-fuz ( na / ) 1.0E10)

;;===== Global Data for User-Interface =======
;;Get File Dialog
;;(defun acet-ui-getfile ( title deffile defext flag / )
;; (getfiled title deffile defext flag)
;;)
;;Entity Selection
(defun acet-ui-entsel ( sellst / retss msg bits keys usewnd filt lockedOK sel addss cursor p1 p2 idx ename locked elayer )
 (setq retss NIL msg NIL bits NIL keys NIL usewnd NIL filt NIL lockedOK NIL)
 (if (not sellst)
  (setq retss (ssget))
  (progn
   (setq msg (nth 0 sellst) bits (nth 1 sellst) keys (nth 2 sellst) usewnd (nth 3 sellst) filt (nth 4 sellst) lockedOK (nth 5 sellst))
   (if (not bits) (setq bits 0))
   (if (not keys) (setq keys ""))
   (if keys (setq keys (strcat keys "  ")))
   (while (not retss)
    (initget bits keys)
    (if msg
      (setq sel (entsel msg))
      (setq sel (entsel))
    )
    (setq addss NIL)
    (if sel
     (progn
      (if (= (type sel) 'STR)  (setq retss sel))
      (if (= (type sel) 'LIST) (setq addss (ssadd (car sel))))
     )
     (if usewnd
      (progn
       (setq cursor (grread T 5 2)) (setq p1 (nth 1 cursor)) (grread T 5 1)
       (initget (+ 8 32))           (setq p2 (getcorner p1))
       (setq addss (ssget "_C" p1 p2 filt))
      )
     )
    )
    ;--- analyse addss for entities ---
    (if addss
     (progn
      (setq idx 0 locked 0)
      (while (setq ename (ssname addss idx))
       (if (not lockedOK)
        (if (setq elayer (cdr (assoc 8 (entget ename))))
         (if (acet-layer-locked elayer) (setq ename NIL locked (1+ locked)))
        )
       )
       (if ename
        (if (not retss)
         (setq retss (ssadd ename))
         (ssadd ename retss)
        )
       )
       (setq idx (1+ idx))
      )
      (if (= locked 1) (prompt "\n1 object was on a locked layer."))
      (if (> locked 1) (prompt (strcat "\n" (itoa locked) " objects were on a locked layer.")))
     )
    )
   )
  )
 )
 (if (= (type retss) 'STR)
  (if (= (strlen retss) 0) (setq retss NIL))
 )
 retss
)
;;Single Entity Select
(defun acet-ui-single-select ( filter flag / a p1 p2 ss ss2 flag2 )
 (setq flag2 NIL ss NIL)
 (while (not flag2)
  (setvar "highlight" 0)
  (if (entnext)
   (progn
    (command "_.select" (entnext) "")
    (command "_.undo" "1")
   )
  )
  (setvar "highlight" 1)
  (command "_.select" "_single")
  (setvar "cmdecho" 1)
  (command pause)

  (setq ss2 (ssget "_P")
         p1 (getvar "lastpoint")
         p1 (trans p1 1 (getvar "viewdir"))
          a (* (getvar "pickbox") (acet-geom-pixel-unit))
         p2 (list (- (car p1) a) (- (cadr p1) a) 0.0)
         p1 (list (+ (car p1) a) (+ (cadr p1) a) 0.0)
         p1 (trans p1 (getvar "viewdir") 1)
         p2 (trans p2 (getvar "viewdir") 1)
  )

  (if (and ss2 (or (setq ss (ssget "_P" filter)) (setq ss (ssget "_C" p1 p2 filter))))
   (progn
    (setq ss (ssname ss 0))
    (if flag
      (setq flag2 T)
      (progn
       (if (acet-layer-locked (cdr (assoc 8 (entget ss))))
        (progn
         (setq flag2 nil)
         (princ "\n* Locked Layer !")
        )
        (setq flag2 T)
       )
      )
    )
   )
   (progn
    (if ss2
     (princ "\nInvalid selection.")
     (setq flag2 T)
    )
   )
  )
  (setvar "cmdecho" 0)
 )
 ss
)
;;Fence Selectino points
(defun acet-ui-fence-select ( / fencepoints lastpnt oldpnt pnt stop userinput incode msg1 msg2 )
 (setq fencepoints NIL)
 (setq stop NIL pnt NIL lastpnt NIL oldpnt NIL)
 (setq msg1 (strcat "\n" (acet::getltexmsg "FenceSelect_FirstPoint" "First Fence Point <Exit> :")))
 (setq msg2 (strcat "\n" (acet::getltexmsg "FenceSelect_NextPoint"  "Next Fence Point <Exit> :")))

 (initget (+ 8 32) "z Z q u U Q  ")
 (setq lastpnt (getpoint msg1))
 (if (and lastpnt (= (type lastpnt) 'LIST))
  (progn
   (setq lastpnt (list (car lastpnt) (cadr lastpnt)))
   (setq fencepoints (cons lastpnt fencepoints))
   (princ msg2)
  )
  (setq stop T)
 )

 (while (not stop)
  ;Get Input
  (setq pnt NIL)
  (setq userinput (grread T 11) incode (nth 0 userinput))
  ;Clear old
  (if (and lastpnt oldpnt) (grdraw lastpnt oldpnt -1 1))
  ;Check Input
  (cond
   ((= incode 3) ; PICK KOORDINATEN
    (setq pnt (nth 1 userinput))
    (setq pnt (list (car pnt) (cadr pnt)))
    (setq fencepoints (cons pnt fencepoints))
    (if (and lastpnt pnt) (grdraw lastpnt pnt -1 1))
    (setq lastpnt pnt)
    (princ msg2)
   )
   ((= incode 5) ; Mouse Coordinates
    (setq pnt (nth 1 userinput))
    (setq pnt (list (car pnt) (cadr pnt)))
   )
   (T (setq stop T))
  )

  ;Draw Fresh
  (if (and pnt (not stop))
   (progn
    (if (and lastpnt pnt (not (equal lastpnt pnt))) (grdraw lastpnt  pnt -1 1))
    (setq oldpnt pnt)
   )
  )
 )

 (if (and fencepoints (<= (length fencepoints) 1)) (setq fencepoints NIL))
 (redraw)
 fencepoints
)
;;Window/Crossing Polygon
(defun acet-ui-polygon-select ( mode / fencepoints firstpnt lastpnt oldpnt pnt stop userinput incode msg1 msg2 )
 (setq fencepoints NIL)
 (setq stop NIL pnt NIL firstpnt NIL lastpnt NIL oldpnt NIL)
 (setq msg1 (strcat "\n" (acet::getltexmsg "PolygonSelect_FirstPoint" "First Polygon Point <Exit> :")))
 (setq msg2 (strcat "\n" (acet::getltexmsg "PolygonSelect_NextPoint"  "Next Polygon Point <Exit> :")))

 (initget (+ 8 32) "z Z q u U Q  ")
 (setq firstpnt (getpoint msg1))
 (if (and firstpnt (= (type firstpnt) 'LIST))
  (progn
   (setq firstpnt (list (car firstpnt) (cadr firstpnt)))
   (setq fencepoints (cons firstpnt fencepoints))
   (princ msg2)
  )
  (setq stop T)
 )

 (while (not stop)
  ;Get Input
  (setq pnt NIL)
  (setq userinput (grread T 11) incode (nth 0 userinput))
  ;Clear old
  (if (and firstpnt oldpnt) (grdraw firstpnt oldpnt -1 mode))
  (if (and lastpnt  oldpnt) (grdraw lastpnt  oldpnt -1 mode))
  ;Check Input
  (cond
   ((= incode 3)  ; PICK KOORDINATEN
    (setq pnt (nth 1 userinput))
    (setq pnt (list (car pnt) (cadr pnt)))
    ;Check Self-Intersect
    (if (not (acet-geom-self-intersect (cons pnt fencepoints) T))
      (progn
        (setq fencepoints (cons pnt fencepoints))
        (if (and (not lastpnt) firstpnt pnt) (grdraw firstpnt pnt -1 mode))
        (if (and lastpnt  pnt) (grdraw lastpnt pnt -1 mode))
        (setq lastpnt pnt)
        (princ msg2)
      )
    )
   )
   ((= incode 5)  ; Mouse Coordinated
    (setq pnt (nth 1 userinput))
    (setq pnt (list (car pnt) (cadr pnt)))
   )
   (T (setq stop T))
  )

  ;Draw Fresh
  (if (and pnt (not stop))
   (progn
    (if (and firstpnt pnt) (grdraw firstpnt pnt -1 mode))
    (if (and lastpnt  pnt (not (equal lastpnt pnt))) (grdraw lastpnt  pnt -1 mode))
    (setq oldpnt pnt)
   )
  )
 )

 (if (and fencepoints (<= (length fencepoints) 1)) (setq fencepoints NIL))
 (redraw)
 fencepoints
)
;;Truncate point list
(defun bns_truncate_2_view ( a b x y x2 y2 / isect )
 (if (and
      (< (car a) x)
      (setq isect (inters a b (list x y 0.0) (list x y2 0.0)))
     )
  (setq a isect)
  (if (and
       (> (car a) x2)
       (setq isect (inters a b (list x2 y 0.0) (list x2 y2 0.0)))
      )
   (setq a isect)
  )
 )
 (if (and
       (< (cadr a) y)
       (setq isect (inters a b (list x y 0.0) (list x2 y 0.0)))
     )
  (setq a isect)
  (if (and
        (> (cadr a) y2)
        (setq isect (inters a b (list x y2 0.0) (list x2 y2 0.0)))
      )
   (setq a isect)
  )
 )
 a
)
;;Set All Groups to Unselect
(defun bns_groups_unsel ( / grpenames grpdict entry ename elist flag )
 (setq grpenames NIL)
 (setq grpdict (dictsearch (namedobjdict) "ACAD_GROUP"))
 (foreach entry grpdict
  (if (= (car entry) 350)  ;; objectname
   (progn
    (setq ename (cdr entry) elist (entget ename))
    (setq flag (cdr (assoc 71 elist)))
    (if (and flag (> flag 0))
     (progn
      (setq grpenames (cons ename grpenames))
      (setq elist (subst (cons 71 0) (assoc 71 elist) elist))
      (entmod elist)
     )
    )
   )
  )
 )
 grpenames
)
;;Set Groups back to Select
(defun bns_groups_sel ( grpenames / ename elist )
 (foreach ename grpdict
  (if (setq elist (entget ename))
   (progn
    (setq elist (subst (cons 71 1) (assoc 71 elist) elist))
    (entmod elist)
   )
  )
 )
 T
)
;;Draw a temporary polyline & let it blink
(defun acet-blink-and-show-object ( lst / na c )
 (setq na (nth 0 lst) c (nth 1 lst))
 (if (and na c) (bns_blink_and_show_object na c))
)
;;Draw a temporary polyline & let it blink
(defun bns_blink_and_show_object ( na color / tim na2 lst vd ss flag w ccol )
 (if (setq lst (getgeomextents na))
  (progn
   (setq ccol (getvar "cecolor"))
   (setvar "cecolor" (itoa color))
   (setq  vd (trans (getvar "viewdir") 1 0 T)
         lst (acet-geom-m-trans lst 0 vd)
         lst (acet-geom-rect-points (car lst) (cadr lst))
         na2 (entlast)
           w (* 2.0 (acet-geom-pixel-unit))
   )
   (acet-lwpline-make (list (list (cons 210 vd) (cons 43 w)) lst))
   (setq na (entlast))
   (if (and na
            (not (equal na na2))
       )
    (progn
     (setq ss (ssadd na) flag 1)
     (repeat 14
       (setq flag (abs (- flag 1)))
       (acet-ss-visible ss flag)
       (entupd na)
       (redraw)
       (setq tim (+ (* (getvar "tdindwg") 10000000) 10))
       (while (<    (* (getvar "tdindwg") 10000000) tim)
       )
     )
     (entdel na)
    )
   )
   (setvar "cecolor" ccol)
  )
 )
)
;;Search all entities inside block table
(defun bns_blktbl_match ( flt / lst a b n lst2 )
 (setq lst (acet-table-name-list "block"))
 (setq n 0)
 (repeat (length lst)
  (setq a (nth n lst)
        a (bns_blk_match a
                         flt
                         nil
                         nil ;do not search nested inserts
          )
        a (car a)
  )
  (if a
   (progn
    (while a
     (setq b (car a)
           b (list (cdr (assoc -1 (car b))) (cadr b))
           a (cdr a)
     )
     (setq lst2 (append lst2 (list b)))
    )
   )
  )
  (setq n (+ n 1))
 )
 lst2
)
;;Search all entities inside specified blocks
(defun bns_blk_match ( blkname flt lst flag / na e1 lst2 )
 (if blkname (setq blkname (strcase blkname)))
 (if (not lst) (setq lst (list blkname)))
 (if (and (equal blkname (last lst))
          (setq na (tblobjname "block" blkname))
          (setq e1 (entget na))
     )
  (progn
   (while (and (setq na (entnext na))
               (setq e1 (entget na))
               (not (equal "BLKEND" (cdr (assoc 0 e1))))
          )
    (if (bns_filter_match e1 flt) (setq lst2 (append lst2 (list (list e1 blkname)))))
    (if (and (equal "INSERT" (cdr (assoc 0 e1)))
             (not (member (cdr (assoc 2 e1)) lst))
             flag
        )
     (setq lst (append lst (list (cdr (assoc 2 e1))))
           lst (bns_blk_match (cdr (assoc 2 e1)) flt lst flag)
          lst2 (append lst2 (car lst))
           lst (cadr lst)
     )
    )
   )
  )
 )
 (list lst2 lst)
)
;;Search all entities inside specified blocks
(defun bns_tbl_match ( tblname flt / n lst na e1 lst2 )
 (setq n 0 lst (acet-table-name-list tblname))
 (repeat (length lst)
  (setq na (tblobjname tblname (nth n lst))
        e1 (entget na)
  )
  (if (bns_filter_match e1 flt) (setq lst2 (append lst2 (list e1))))
  (setq n (+ n 1))
 )
 lst2
)
(defun bns_filter_match ( e1 flt / a flag )
 (setq flag T)
 (while (and flt flag)
  (setq a (car flt) flt (cdr flt))
  (if (equal -4  (car a))
   (setq  flt (bns_-4_match a e1 flt)
         flag (cadr flt)
          flt (car flt)
   )
   (setq flag (bns_gc_match e1 a nil))
  )
 )
 flag
)
(defun bns_-4_match ( a e1 flt / b c opr )
 (setq b (strcase (cdr a)) a (car a))
 (cond
  ((equal b "<OR")  (setq flt (bns_or_match  e1 flt)))
  ((equal b "<AND") (setq flt (bns_and_match e1 flt)))
  ((equal b "<NOT") (setq flt (bns_not_match e1 flt)))
  (T
   (setq c (car flt) flt (cdr flt))
   (cond
    ((equal b "*") (setq flt (list flt T)))
    ((or (equal b "!=") (equal b "<>")) (setq flt (list flt (bns_gc_match e1 c /=))))
    ((equal b "&")
     (setq opr '(( a b / )
                 (> (logand a b) 0)
                )
           flt (list flt (bns_gc_match e1 c opr))
     )
    )
    ((equal b "&=")
     (setq opr '(( a b / )
                 (equal a (logior a b))
                )
           flt (list flt (bns_gc_match e1 c opr))
     )
    )
    ((eval (read b))
     (setq opr (eval (read b))
           flt (list flt (bns_gc_match e1 c opr))
     )
    )
   )
  )
 )
 flt
)
(defun bns_or_match ( e1 flt / lst a flag )
 (while (and (not flag) flt)
  (setq a (car flt) flt (cdr flt))
  (if (and (equal -4 (car a))
           (equal (strcase (cdr a)) "OR>")
      )
   (setq flag T)
   (setq lst (append lst (list a)))
  )
 )

 (setq flag nil)
 (while (and lst (not flag))
  (setq a (car lst) lst (cdr lst))
  (if (equal -4 (car a))
   (setq  lst (bns_-4_match a e1 lst)
         flag (cadr lst)
          lst (car lst)
   )
   (setq flag (bns_gc_match e1 a nil))
  )
 )
 (list flt flag)
)
(defun bns_and_match ( e1 flt / lst a flag )
 (while (and (not flag) flt)
  (setq a (car flt) flt (cdr flt))
  (if (and (equal -4 (car a))
           (equal (strcase (cdr a)) "AND>")
      )
   (setq flag T)
   (setq lst (append lst (list a)))
  )
 )

 (setq flag T)
 (while (and lst flag)
  (setq a (car lst) lst (cdr lst))
  (if (equal -4 (car a))
   (setq lst (bns_-4_match a e1 lst)
        flag (and flag (cadr lst))
         lst (car lst)
   )
   (setq flag (and flag (bns_gc_match e1 a nil)))
  )
 )
 (list flt flag)
)
(defun bns_not_match ( e1 flt / lst a flag )
 (while (and (not flag) flt)
  (setq a (car flt) flt (cdr flt))
  (if (and (equal -4 (car a))
           (equal (strcase (cdr a)) "NOT>")
      )
   (setq flag T)
   (setq lst (append lst (list a)))
  )
 )

 (setq flag T)
 (while (and lst flag)
  (setq a (car lst) lst (cdr lst))
  (if (equal -4 (car a))
   (setq lst (bns_-4_match a e1 lst)
        flag (not (cadr lst))
         lst (car lst)
   )
   (setq flag (not (bns_gc_match e1 a nil)))
  )
 )
 (list flt flag)
)
(defun bns_gc_match ( e1 dp opr / dp2 a b c d flag )
 (if (not opr) (setq opr equal))
 (setq a (car dp) b (cdr dp))
 (if (equal (type b) 'STR) (setq b (strcase b)))

 (setq dp2 (assoc a e1) c (car dp2) d (cdr dp2))
 (if (equal (type d) 'STR) (setq d (strcase d)))

 (if dp2
  (if (eval (append '(opr) (list b d)))
   (setq flag T)
   (cond
    ((and (equal (type b) 'STR)
          (equal (type d) 'STR)
          (and (equal opr equal)
               (wcmatch d b)
          )
     )
     (setq flag T)
    )
   )
  )
 )
 flag
)

;;====== Global Data for DCL Controls ========
;;Display List Values
(defun acet-dcl-list-make ( dcltile vallist / entry )
 (start_list dcltile)
 (foreach entry vallist (add_list entry))
 (end_list)
 (princ)
)

;;====== Global Data for List Handling =======
(defun acet-list-put-nth ( newval datalist atidx / retlist idx entry )
 (setq retlist NIL idx 0)
 (foreach entry datalist
  (if (= idx atidx)
   (setq retlist (cons newval retlist))
   (setq retlist (cons entry  retlist))
  )
  (setq idx (1+ idx))
 )
 (reverse retlist)
)
;;Remove Entry at Index
(defun acet-list-remove-nth ( atidx datalist / retlist idx entry )
 (setq retlist NIL idx 0)
 (foreach entry datalist
  (if (/= idx atidx) (setq retlist (cons entry retlist)))
  (setq idx (1+ idx))
 )
 (reverse retlist)
)
;;Remove all Entries by Key
(defun acet-list-assoc-remove ( key datalist / retlist entry )
 (setq retlist NIL)
 (foreach entry datalist
  (if (/= (car entry) key) (setq retlist (cons entry retlist)))
 )
 (reverse retlist)
)
;;Remove Duplicates from List
(defun acet-list-remove-adjacent-dups ( datalist / retlist entry )
 (setq retlist NIL)
 (foreach entry datalist
  (if (not (member entry retlist)) (setq retlist (cons entry retlist)))
 )
 (reverse retlist)
)
;;Remove duplicate points from List
(defun acet-list-remove-duplicate-points ( lst fuz / retlist testlist p1 p2 )
 (setq retlist NIL)
 (if (not fuz) (setq fuz 0.0))
 (foreach p1 datalist
  (setq found NIL testlist retlist)
  (while (and (not found) (setq p2 (car testlist) testlist (cdr testlist)))
   (if (<= (distance p1 p2) fuz) (setq found T))
  )
  (if (not found) (setq retlist (cons p1 retlist)))
 )
 (reverse retlist)
)
;; group data by assoc key
(defun acet-list-group-by-assoc ( lst / retlst sublst key keyval entry newentry )
 (setq retlst NIL)
 (foreach sublst lst
   (setq key (car sublst) keyval (cdr sublst))
   (setq entry (assoc key retlst))
   (if entry
     (setq newentry (append entry keyval)
           retlst   (subst newentry entry retlst)
     )
     (setq retlst (cons sublst retlst))
   )
 )
 retlst
)
;;add defaults to elist
(defun acet-elist-add-defaults ( elist / newlist tmplist entry key )
 (setq newlist elist)
 (if (not (assoc 8 newlist)) ;layer
  (progn
   (setq key 100)
   (if (assoc  67 newlist) (setq key  67))
   (if (assoc 410 newlist) (setq key 410))
   (setq tmplist NIL)
   (foreach entry newlist
     (setq tmplist (cons entry tmplist))
     (if (= (car entry) key) (setq tmplist (cons (cons 8 (getvar "clayer")) tmplist)))
   )
   (setq newlist (reverse tmplist))
  )
 )
 (if (not (assoc 62 newlist)) ;color
  (progn
   (setq tmplist NIL)
   (foreach entry newlist
     (setq tmplist (cons entry tmplist))
     (if (= (car entry) 8) (setq tmplist (cons (cons 62 256) tmplist)))
   )
   (setq newlist (reverse tmplist))
  )
 )
 (if (not (assoc 6 newlist)) ;ltype
  (progn
   (setq tmplist NIL)
   (foreach entry newlist
     (setq tmplist (cons entry tmplist))
     (if (= (car entry) 8) (setq tmplist (cons (cons 6 (getvar "celtype")) tmplist)))
   )
   (setq newlist (reverse tmplist))
  )
 )
 (if (not (assoc 370 newlist)) ;lineweight
  (progn
   (setq tmplist NIL)
   (foreach entry newlist
     (setq tmplist (cons entry tmplist))
     (if (= (car entry) 62) (setq tmplist (cons (cons 370 -1) tmplist)))
   )
   (setq newlist (reverse tmplist))
  )
 )
 newlist
)

;;===== Global Data for String Routines ======
;;Trim Left / Right Characters
(defun acet-str-lr-trim ( s str / retstr idx )
 (setq retstr str)
 ;;------ trim left -----
 (setq idx 1)
 (while (= (substr retstr idx 1) s) (setq idx (1+ idx)))
 (setq retstr (substr retstr idx))
 ;;------ trim right ----
 (setq idx (strlen retstr))
 (while (and (> idx 0) (= (substr retstr idx 1) s)) (setq idx (1- idx)))
 (if (> idx 0) (setq retstr (substr retstr 1 idx)))
 retstr
)
;;Trim Left / Right Spaces
(defun acet-str-space-trim ( str / retstr idx )
 (acet-str-lr-trim " " str)
)
;;place escape for wildcard strings
(defun acet-str-esc-wildcards ( str / retstr onechr idx )
 (setq idx 1 retstr "")
 (repeat (strlen str)
  (setq onechr (substr str idx 1))
  (if (or
       (= onechr "#") (= onechr "?") (= onechr ".")
       (= onechr "*") (= onechr "~") (= onechr ",")
       (= onechr "[") (= onechr "]") (= onechr "@")
      )
   (setq retstr (strcat retstr "`" onechr))
   (setq retstr (strcat retstr onechr))
  )
  (setq idx (1+ idx))
 )
 retstr
)
;;Split String into List
(defun acet-str-to-list ( deli line / word wordlist idx long char1 )
 (setq wordlist NIL long (strlen line) idx 1)
 (while (and (> long 0) (<= idx long))
  (setq char1 (substr line idx 1))
  (cond
   ((= char1 deli)
    (setq word (substr line 1 (1- idx)))
    (setq line (substr line (1+ idx)) idx 0)
    (setq wordlist (cons word wordlist))
   )
   ((= char1 "\"")
    (setq idx (1+ idx))
    (while (and
             (<= idx long)
             (/= (substr line idx 1) "\"")    ; Suche naechstes <">
           )
     (setq idx (1+ idx))
    )
   )
  )
  (setq idx (1+ idx) long (strlen line))
 )
 (if (> (strlen line) 0) (setq wordlist (cons line wordlist)))
 (reverse wordlist)
)
;;Find multiple Substrings
(defun acet-str-m-find ( find str / retlist idx long olong )
 (setq retlist NIL long (strlen str) olong (strlen find))
 (if (> olong long) (setq long 0))
 (setq idx 1)
 (while (<= idx long)
  (if (= (substr str idx olong) find) (setq retlist (cons idx retlist)))
  (setq idx (1+ idx))
 )
 (reverse retlist)
)
;;Compare Strings Insensitive
(if (not acet-str-equal)  ;; not present in AcetUtil.arx Vol.1-8
 (defun acet-str-equal ( str1 str2 / s1 s2 IsEqual )
  (setq IsEqual NIL)
  (if (and str1 str2)
   (setq s1 (strcase (acet-str-space-trim str1)) s2 (strcase (acet-str-space-trim str2)))
  )
  (if (= s1 s2) (setq IsEqual T))
  IsEqual
 )
)
;;Remove backslash controls
(defun acet-bs-strip ( str / i ilen ch retstr )
 (setq retstr "" ilen (strlen str) i 1)
 (repeat ilen
  (setq ch (substr str i 1))
  (setq retstr (strcat retstr ch))
  (setq i (1+ i))
 )
 retstr
)

;;====== Global Data for File Handling =======
(setq ET$BackupFiles NIL)
;;Remove Extension from File
(defun acet-filename-ext-remove ( file / retfile tpos )
 (setq retfile (acet-str-space-trim file))
 (setq tpos (acet::pos-filetype retfile))
 (if (> tpos 0) (setq retfile (substr retfile 1 (- tpos 1))))
 retfile
)
;;Get Filename Without Path
(defun acet-filename-path-remove ( file / )
 (acet::nameonly (acet-str-space-trim file))
)
;;Get Extension from Filename
(defun acet-filename-extension ( file / )
 (acet::filetype (acet-str-space-trim file))
)
;;Get Directory from Filename
(defun acet-filename-directory ( file / )
 (acet::pathonly (acet-str-space-trim file))
)
;;Check for Proper Filename
(defun acet-filename-valid ( file / IsValid )
 (setq IsValid NIL)
 (if file (setq file (acet-str-space-trim file)))
 (if (and file (> strlen file) 0) (setq IsValid T))
 IsValid
)
;;Remove Path, if file is inside Supportpathes
(defun acet-filename-supportpath-remove ( file / retfile )
 (setq file (acet-str-space-trim file))
 (setq retfile (acet::nameonly file))
 (if (not (findfile retfile)) (setq retfile file))
 retfile
)
;;Extended FindFile
(defun acet-file-find ( file / retfile shortfile otherpath )
 (setq file (acet-str-space-trim file))
 (setq retfile (findfile file))
 (if (not retfile) (setq shortfile (acet::nameonly file)))
 (if (not retfile) (setq retfile (findfile shortfile)))
 ;;Test Acad Path
 (if (not retfile)
  (if ltex$get_acad_path
   (if (setq otherpath (ltex$get_acad_path))
    (setq retfile (findfile (strcat otherpath "\\" shortfile)))
   )
  )
 )
 ;;Test Express Path
 (if (not retfile)
  (if ltex$get_express_path
   (if (setq otherpath (ltex$get_express_path))
    (setq retfile (findfile (strcat otherpath "\\" shortfile)))
   )
  )
 )
 ;;Test Extender Path
 (if (not retfile)
  (if ltex$get_install_path
   (if (setq otherpath (ltex$get_install_path))
    (setq retfile (findfile (strcat otherpath "\\" shortfile)))
   )
  )
 )
 retfile
)
;;Extended FindFile (Fonts)
(defun acet-file-find-font ( fontfile / retfont ftype shortfile winfontpath )
 (setq winfontpath NIL)
 (setq fontfile (acet-str-space-trim fontfile))
 (setq retfont (acet-file-find fontfile))
 (if (not retfont) (setq retfont (acet-file-find (strcat fontfile ".shx"))))
 (if (not retfont) (setq retfont (acet-file-find (strcat fontfile ".ttf"))))
 (if (not retfont)
  (progn
   (if ltex$get_winfont_path (setq winfontpath (ltex$get_winfont_path)))
   (setq shortfile (acet::nameonly fontfile))
   (if winfontpath (setq shortfile (strcat winfontpath "\\" shortfile)))
   (setq retfont (acet-file-find shortfile))
   (if (not retfont) (setq retfont (acet-file-find (strcat shortfile ".shx"))))
   (if (not retfont) (setq retfont (acet-file-find (strcat shortfile ".ttf"))))
  )
 )
 retfont
)
;;Extended FindFile (Fonts)
(defun acet-file-find-image ( imgfile / retimg )
 (setq imgfile (acet-str-space-trim imgfile))
 (setq retimg  (acet-file-find imgfile))
 (if (not retimg) (setq retimg (acet-file-find (strcat imgfile ".bmp"))))
 (if (not retimg) (setq retimg (acet-file-find (strcat imgfile ".gif"))))
 (if (not retimg) (setq retimg (acet-file-find (strcat imgfile ".jpg"))))
 retimg
)
;;Create Backup file
(defun acet-file-backup ( file / bakfile )
 (if (setq file (findfile file))
  (progn
   (setq bakfile (strcat (acet-filename-ext-remove file) "_bak" (acet::filetype file)))
   (acet-file-copy file bakfile)
   (setq ET$BackupFiles (cons bakfile ET$BackupFiles))
  )
 )
 NIL
)
;;Delete All Backup files
(defun acet-file-backup-delete ( / bakfile )
 (foreach bakfile ET$BackupFiles (acet-file-remove bakfile))
 (setq ET$BackupFiles NIL)
 T
)
;;Get Application for file
(defun acet-filename-associated-app ( filename / appname ftype entry1 entry2 key val idx )
 (setq appname "Notepad.exe")
 (if (and filename (setq ftype (acet::filetype filename)))
  (if acet-reg-get
   (progn
    (setq entry1 (acet-reg-get (strcat "HKEY_CLASSES_ROOT\\" ftype "\\shell\\open\\command")))
    (setq entry2 (acet-reg-get (strcat "HKEY_CLASSES_ROOT\\" ftype)))
    (if entry2
     (setq entry2 (acet-reg-get (strcat "HKEY_CLASSES_ROOT\\" entry2 "\\shell\\open\\command")))
    )
    (if entry1
     (setq appname entry1)
     (if entry2 (setq appname entry2))
    )
    (setq appname (acet-str-space-trim appname))
    (if (> (setq idx (acet-str-find "%" appname)) 0)
     (setq appname (acet-str-space-trim (substr appname 1 (- idx 1))))
    )
   )
  )
 )
 appname
)

;;====== Global Data for File Loading ========
(defun get-defparts ( cmd / cmdname cmdpar idx slen )
 (setq cmdname "" cmdpar "" idx 1 slen (strlen cmd))
 (while (<= idx slen)
  (cond
   ((= (substr cmd idx 1) " ")
    (setq cmdname (substr cmd 1 (- idx 1)) cmdpar (substr cmd (+ idx 1)) idx slen)
   )
   ((= (substr cmd idx 1) ")")
    (setq cmdname (substr cmd 1 (- idx 1)) cmdpar "")
   )
  )
  (setq idx (1+ idx))
 )
 (setq slen (strlen cmdpar))
 (if (and (> slen 0) (= (substr cmdpar slen 1) ")")) (setq cmdpar (substr cmdpar 1 (- slen 1))))
 (list cmdname cmdpar)
)
(defun acet-arxload-or-bust ( filename / ) (arxload filename))
;;Test & Load function & file
(defun acet-autoload ( loadlist / prgfile prgfunc ftype sCmdDef sCmdHead loadstr lispcall defparts strprinc defpart_1 defpart_2 )
 (setq prgfile (car loadlist) loadlist (cdr loadlist))
 (setq prgfunc (car loadlist))
 (if prgfunc (setq prgfunc (strcase prgfunc)))
 (setq lispcall prgfunc)     ;; save original call

 (if (and prgfile prgfunc (setq prgfile (acet::expandfn prgfile NIL)))
  (progn
   (if (= (substr prgfunc 1 1) "(") (setq prgfunc (substr prgfunc 2)))
   (if prgfunc
    (progn
     (setq strprinc "" defparts (get-defparts prgfunc))
     (setq defpart_1 (car defparts) defpart_2 (cadr defparts))

     (setq sCmdHead (strcat "(defun " defpart_1 " ( " defpart_2 " )"))

     (if (= (substr defpart_1 1 2) "C:") (setq strprinc "(princ)"))

     (setq ftype (strcase (acet::filetype prgfile)))
     (if (= ftype "") (setq prgfile (strcat prgfile ".lsp")))

     (cond
      ((= ftype ".ARX") (setq loadstr (strcat " (if (arxload \"" prgfile "\") " lispcall ")" strprinc ")")))
      (T                (setq loadstr (strcat " (if (ltload \"" prgfile "\" nil) " lispcall ")" strprinc ")")))
     )
     (setq sCmdDef (strcat sCmdHead loadstr))

     (if (not (member prgfile ET$ACETFILESFOUND))
      (if (findfile prgfile) (setq ET$ACETFILESFOUND (cons prgfile ET$ACETFILESFOUND)))
     )

     (if (member prgfile ET$ACETFILESFOUND) (eval (read sCmdDef)))
    )
   )
  )
 )
 (princ)
)
(defun acet-autoload2 ( loadlist / fname ftype )
 (setq fname (car loadlist) ftype (strcase (acet::filetype fname)))
 (if (= ftype "") (setq fname (strcat fname ".lsp")))
 (if (not (member fname ET$ACETFILESFOUND))
  (if (findfile fname)
   (progn
    (setq ET$ACETFILESFOUND (cons fname ET$ACETFILESFOUND))
    (cond
     ((= ftype ".ARX") (arxload fname))
     (T                (load fname))
    )
   )
  )
 )
 (princ)
)
(defun acet-autoloadarx ( loadlist / prgfile prgfunc exefunc ftype sCmdDef sCmdHead loadstr lispcall defparts strprinc defpart_1 defpart_2 )
 (setq prgfile (car loadlist) loadlist (cdr loadlist))
 (setq prgfunc (car loadlist) loadlist (cdr loadlist))
 (setq exefunc (car loadlist))
 (if prgfunc (setq prgfunc (strcase prgfunc)))
 (if exefunc (setq exefunc (strcase exefunc)))
 (setq lispcall prgfunc)     ;; save original call

 (if exefunc (setq lispcall exefunc))
 (if (and prgfile prgfunc (setq prgfile (acet::expandfn prgfile NIL)))
  (progn
   (if (= (substr prgfunc 1 1) "(") (setq prgfunc (substr prgfunc 2)))
   (if prgfunc
    (progn
     (setq strprinc "" defparts (get-defparts prgfunc))
     (setq defpart_1 (car defparts) defpart_2 (cadr defparts))

     (setq sCmdHead (strcat "(defun " defpart_1 " ( " defpart_2 " )"))

     (if (= (substr defpart_1 1 2) "C:") (setq strprinc "(princ)"))

     (setq ftype (strcase (acet::filetype prgfile)))
     (if (= ftype "") (setq prgfile (strcat prgfile ".lsp")))

     (cond
      ((= ftype ".ARX") (setq loadstr (strcat " (if (arxload \"" prgfile "\") " lispcall ")" strprinc ")")))
      (T                (setq loadstr (strcat " (if (load \"" prgfile "\") " lispcall ")" strprinc ")")))
     )
     (setq sCmdDef (strcat sCmdHead loadstr))

     (if (not (member prgfile ET$ACETFILESFOUND))
      (if (findfile prgfile) (setq ET$ACETFILESFOUND (cons prgfile ET$ACETFILESFOUND)))
     )

     (if (member prgfile ET$ACETFILESFOUND) (eval (read sCmdDef)))
    )
   )
  )
 )
 (princ)
)

;;==== Global Data for Viewport Functions ====
;;Get Next Pickable VP
(defun acet-viewport-next-pickable ( / retval msg clayout ss elist vpid )
 (setq retval (list 2 NIL)) ;; default
 (if (= (getvar "TILEMODE") 0)
  (progn
   (setq msg (strcat "\n " (acet::getltexmsg "NoMSViewports" "No active Modelspace Viewports present.")))
   (setq clayout (getvar "CTAB"))
   (if (<= (getvar "cvport") 1)
    (setq ss (ssget "X" (list (cons 0 "VIEWPORT")(cons 410 clayout)(cons 68 2))))
    (setq ss (ssget "X" (list (cons 0 "VIEWPORT")(cons 410 clayout)(cons 68 1))))
   )
   (if (not ss)
    (setq retval (list nil msg))
    (progn
     (setq elist (entget (ssname ss 0)))
     (setq vpid (cdr (assoc 69 elist)))
     (if (<= vpid 1)
      (setq retval (list nil msg))
      (setq retval (list vpid NIL))
     )
    )
   )
  )
 )
 retval
)
;;Get Next Pickable VP
(defun acet-viewport-frozen-layer-list ( ename / fllst elist xdata entry )
 (setq fllst NIL)
 (setq elist (entget ename '("ACAD")))
 (setq xdata (cdr (assoc -3 elist)))
 (setq xdata (cdr (assoc "ACAD" xdata)))
 (setq xdata (cdr (member (assoc 1002 xdata) xdata)))
 (setq xdata (cdr (member (assoc 1002 xdata) xdata)))
 (while (and (not (equal (car xdata) (assoc 1002 xdata)))
             (setq entry (assoc 1003 xdata))
             (setq xdata (cdr (member entry xdata)))
             (setq entry (cdr entry))
        )

  (setq fllst (cons entry fllst))
 )
 (reverse fllst)
)

;;===== Global Data for Misc. Calculation ====
(setq ET$TempSegment NIL)
;;Calculate Bit Values
(defun acet-calc-bitlist ( n / retlist bits step )
 (setq retlist NIL bits 1 step 0)
 (while (< step 16)
  (if (= (logand bits n) bits) (setq retlist (cons bits retlist)))
  (setq bits (* 2 bits) step (1+ step))
 )
 (reverse retlist)
)
;;Round Value
(defun acet-calc-round ( rval rround / retval fixscale restval )

 (setq rval (float rval) rround (abs (float rround)))
 (if (< rval 0.0) (setq rround (* -1.0 rround)))
 (if (< (abs rval) (abs rround)) (setq rval 0.0 rround 0.0))
 (if (= rround 0.0)
  (setq retval rval)
  (progn
   (setq fixscale (fix (/ rval rround)))
   (setq retval   (* fixscale rround))
   (setq restval  (- rval retval))
   (if (> restval (* 0.5 rround)) (setq retval (+ retval rround)))
  )
 )
 retval
)
;; Calculate Tangens
(defun acet-calc-tan ( a / )
 (/ (sin a) (cos a))
)
;;Create LW Polyline
(defun acet-lwpline-make ( lst / pt elist plst ucslist )
 (setq plst (last lst))
 (setq elist (list '(0   . "LWPOLYLINE")
                   '(100 . "AcDbEntity")
                   '(100 . "AcDbPolyline")
                    (cons 90 (length plst))
                   '(70  . 0)
                   '(43  . 0.0)
                    (if (caddr (car plst))
                       (cons 38 (caddr (car plst)))
                      '(38 . 0.0)
                    )
          )
 )
 (if (> (length lst) 1)  ;; ucs is given in first sub-list
  (progn
   (setq ucslist (car lst))
   (setq elist (append elist (list (car ucslist))))
  )
 )
 (foreach pt plst
  (setq elist (append elist (list (list 10 (car pt) (cadr pt)))))
 )
 (if (> (length plst) 1) (entmake elist))
 (princ)
)
;;Draw tempory Segment
(defun acet-temp-segment ( p1 p2 p3 mode / )
 (if ET$TempSegment
  (progn
   (if (and (car ET$TempSegment) (cadr ET$TempSegment))
    (grdraw (car ET$TempSegment) (cadr ET$TempSegment) 0)
   )
   (if (and (cadr ET$TempSegment) (caddr ET$TempSegment))
    (grdraw (cadr ET$TempSegment) (caddr ET$TempSegment) 0)
   )
  )
 )
 (setq ET$TempSegment nil)
 (if p2
  (progn
   (if (and p1 p2) (grdraw p1 p2 7 mode))
   (if (and p2 p3) (grdraw p2 p3 7 mode))
   (setq ET$TempSegment (list p1 p2 p3))
  )
 )
 (princ)
)

;;======= Other common tool functions =======
;;WMF IN
(defun acet-wmfin ( wmffile / retss ftype filename scrview upperleft ename elist blkname )
 (setq retss (ssadd))
 (setq ftype (acet::filetype wmffile))
 (if (<= (strlen ftype) 0) (setq wmffile (strcat wmffile ".wmf")))
 (if (setq filename (findfile wmffile))
  (progn
   (setq scrview (acet-geom-view-points))
   (setq upperleft (list (caar scrview) (cadadr scrview)))
   (command "_.wmfin" filename upperleft "2" "" "")

   (setq ename (entlast) elist (entget ename))
   (setq blkname (acet-dxf 2 elist))

   (command "_.explode" ename)
   (while (setq ename (entnext ename)) (ssadd ename retss))

   (command "_.purge" "_block" blkname "_no")

   (acet-file-remove filename)
  )
 )
 retss
)
;;Get dxf value from assoc list
(defun acet-dxf ( key keylist / retval )
 (setq retval (cdr (assoc key keylist)))
 (if (and retval (= (type retval) 'STR)) (setq retval (strcase retval)))
 retval
)

;;;============== FROM VOL 1-9 ================
;;format angle 0...2*PI
(defun acet-angle-format ( ang / retang rval )
 (setq divis (abs (fix (/ ang 2.0 PI))))
 (if (/= divis 0) (setq ang (/ ang divis)))
 (if (> ang (+ PI PI)) (setq ang (- ang PI PI)))
 (if (> ang (+ PI PI)) (setq ang (- ang PI PI)))
 (if (< ang 0.0) (setq ang (+ ang PI PI)))
 (if (< ang 0.0) (setq ang (+ ang PI PI)))
 ang
)
;;Compare Angles with Tolerance
(defun acet-angle-equal ( a b fuz / twoPI ret )
 (setq ret NIL)
 (setq twoPI (* PI 2.0))
 (if (not fuz) (setq fuz 0.0))
 (while (>= a twoPI) (setq a (- a twoPI)))
 (while (<  a 0.0)   (setq a (+ a twoPI)))
 (while (>= b twoPI) (setq b (- b twoPI)))
 (while (<  b 0.0)   (setq b (+ b twoPI)))
 (if (<= (abs (- a b)) (abs fuz)) (setq ret T))
 ret
)
;;Compare Degree <> Radians
(defun acet-dtor ( a / ) (* PI (/ a 180.0)))
(defun acet-rtod ( a / ) (* 180.0 (/ a PI)))
;;Get Dictionary entry
(defun acet-dict-ename ( dictname dictentry / entry ename )
 (setq ename NIL)
 (if (setq entry (dictsearch (namedobjdict) dictname))
  (if (setq entry (cdr (assoc -1 entry)))
   (if (setq entry (dictsearch entry dictentry)) (setq ename (cdr (assoc -1 entry))))
  )
 )
 ename
)
;;Get Dictionary entries
(defun acet-dict-name-list ( dictname / dictlist entry entries )
 (setq entries NIL dictlist (dictsearch (namedobjdict) dictname))
 (while dictlist
  (setq entry (car dictlist) dictlist (cdr dictlist))
  (if (= (car entry) 3) (setq entries (append entries (list (cdr entry)))))
 )
 entries
)
;;Explode SS and return exploded entities
(defun acet-explode ( na / ss lastename retss ssidx svar fidx )
 (setq ss (ssadd))
 (if (= (type na) 'ENAME) (setq ss (ssadd na)))
 (if (= (type na) 'PICKSET) (setq ss na))
 (setq retss (ssadd) lastename (entlast) ssidx 0.0)
 (while (setq ename (ssname ss ssidx))
  (command "_.explode" ename)
  (setq svar (getvar "CMDNAMES"))
  (setq fidx (acet-str-find "EXPLODE" svar))
  (if (and (/= svar "") fidx (> fidx 0)) (command ""))
  (setq ssidx (+ ssidx 1.0))
 )
 (while (setq lastename (entnext lastename)) (ssadd lastename retss))
 retss
)
;;Add / Update entry to list
(defun acet-list-assoc-put ( new lst / key entry retlst )
 (setq retlst lst)
 (if (setq key (car new))
  (progn
   (if (setq entry (assoc key retlst))
    (setq retlst (subst new entry retlst))
    (setq retlst (append retlst (list new)))
   )
  )
  (setq retlst (append retlst (list new)))
 )
 retlst
)
;;Append entry to list
(defun acet-list-assoc-append ( new lst / key entry retlst )
 (setq retlst lst)
 (if (setq key (car new))
  (progn
   (if (setq entry (assoc key retlst))
    (setq retlst (subst (append entry (cdr new)) entry retlst))
    (setq retlst (cons new retlst))
   )
  )
  (setq retlst (cons new retlst))
 )
 retlst
)
;;Check (LW)Polyline for 2D
(defun acet-pline-is-2d ( elist / ret etype flag )
 (setq ret T)
 (setq etype (strcase (cdr (assoc 0 elist))))
 (if (= etype "POLYLINE")
  (if (setq flag (cdr (assoc 70 elist)))
   (if (> (logand flag (+ 8 16 32 64)) 0) (setq ret NIL))
  )
 )
 ret
)
;;Get other corner with selection rubberband
(defun acet-ui-getcorner ( p1 / )
 (getcorner p1 (strcat "\n" (acet::getltexmsg "Other_Corner" "Other corner: ")))
)
;;Scale Point from RefPoint by Scale
;;undo begin
(defun acet-undo-begin ( / ) (command "_undo" "_end" "_undo" "_begin"))
;;undo end
(defun acet-undo-end ( / ) (command "_undo" "_e"))
;;undo command exit
(defun acet-cmd-exit ( / ) (command)(command) (princ))
;;execute commands in safe mode
(defun acet-safe-command ( bStart bAutoEnd cmdList / sCmd sEntry )
 (if cmdList
  (progn
   (if bStart
    (progn
     (foreach sEntry cmdList (command sEntry))
     (if bAutoEnd (command))
    )
   )
   (if (not bStart)
    (progn
     (setq sCmd (getvar "cmdnames"))
     (while (and (/= sCmd "") (= sCmd (getvar "cmdnames"))) (command (car cmdList)))
    )
   )
  )
 )
 T
)
;;Get Support Pathes as list
(defun acet-pref-supportpath-list ( / acadprefix )
 (setq acadprefix (getvar "acadprefix"))
 (acet-str-to-list ";" acadprefix)
)

;;Indexed Sort
(defun acet-list-isort ( plst index / ) (isort plst index))
(defun isort ( plst code / lst n a lst2 lst3 j k )
 (setq n 0)
 (repeat (length plst)
  (setq a (nth n plst) a (nth code a))
  (if (equal (type a) 'STR) (setq a (strcase a)))
  (setq a (list n a))
  (setq lst3 (cons a lst3))
  (setq n (+ n 1))
 )
 (setq lst3 (reverse lst3))
 (setq lst (subsort2 lst3) a (length lst3))
 (while (< (length lst) a)
  (setq n 0 j (length lst))
  (repeat j
   (setq lst2 (nth n lst) k (length lst))
   (if (> (length lst2) 1)
    (progn
     (setq  lst (split2 n lst)
           lst2 (subsort2 lst2)
            lst (append (car lst) lst2 (cadr lst))
              n (+ n (- (length lst) k) 1)
     )
    )
    (setq n (1+ n))
   )
  )
 )
 (setq  n 0 lst2 nil)
 (repeat (length lst)
  (setq lst2 (cons (nth (car (car (nth n lst))) plst) lst2))
  (setq n (1+ n))
 )
 (setq lst2 (reverse lst2))
 lst2
)
(defun subsort2 ( lst / a b n lst2 lst3 lst4 )
 (if (equal 2 (length lst))
  (progn
   (if (<= (cadr (car lst)) (cadr (cadr lst)))
    (setq lst2 (list (car lst))
          lst4 (list (cadr lst))
    )
    (setq lst2 (list (cadr lst))
          lst4 (list (car lst))
    )
   )
  )
  (progn
   (setq n 0 a (cadr (nth 0 lst)))
   (repeat (length lst)
    (setq b (nth n lst))
    (cond
     ((< (cadr b) a) (setq lst2 (cons b lst2)))
     ((= (cadr b) a) (setq lst3 (cons (list b) lst3)))
     ((> (cadr b) a) (setq lst4 (cons b lst4)))
    )
    (setq n (+ n 1))
   )
   (setq lst2 (reverse lst2)
         lst3 (reverse lst3)
         lst4 (reverse lst4)
   )
  )
 )
 (setq lst nil)
 (if lst2 (setq lst (append lst (list lst2))))
 (if lst3 (setq lst (append lst lst3)))
 (if lst4 (setq lst (append lst (list lst4))))
 lst
)
(defun split2 ( a lst / lst2 lst3 )
 (setq a (nth a lst))
 (setq lst3 (cdr (member a lst))
       lst2 (reverse (cdr (lastmember a (reverse lst))))
 )
 (list lst2 lst3)
)
(defun lastmember ( a lst / lst2 )
 (while (setq lst (member a lst))
  (setq lst2 lst lst (cdr lst))
 )
 lst2
)
;;Force Acad Screen Refresh
(defun acet-acad-refresh ( / )
 (command "_.zoom" "1.000001x")
 (command "_.zoom" "_prev")
 (princ)
)
;;Get extents of selection set
(defun acet-geom-ss-extents ( ss shrink / ssidx ename plist entry p1 p2 pmid xmin xmax ymin ymax zmin zmax z z1 z2 )
 (setq xmin 1.0E30 xmax -1.0E30 ymin 1.0E30 ymax -1.0E30 zmin 1.0E30 zmax -1.0E30 ssidx 0)
 (while (setq ename (ssname ss ssidx))
  (setq plist (acet-geom-object-point-list ename NIL))
  (setq entry (acet-geom-list-extents plist))
  (setq p1 (car entry) p2 (cadr entry))
  (setq z1 (caddr p1) z2 (caddr p2))
  (if (not z1) (setq z1 0.0))
  (if (not z2) (setq z2 0.0))

  (if (< (car  p1) xmin) (setq xmin (car  p1)))
  (if (> (car  p1) xmax) (setq xmax (car  p1)))
  (if (< (cadr p1) ymin) (setq ymin (cadr p1)))
  (if (> (cadr p1) ymax) (setq ymax (cadr p1)))

  (if (< (car  p2) xmin) (setq xmin (car  p2)))
  (if (< (cadr p2) ymin) (setq ymin (cadr p2)))
  (if (> (car  p2) xmax) (setq xmax (car  p2)))
  (if (> (cadr p2) ymax) (setq ymax (cadr p2)))

  (if (< z1 zmin) (setq zmin z1))
  (if (< z2 zmin) (setq zmin z2))
  (if (> z1 zmax) (setq zmax z1))
  (if (> z2 zmax) (setq zmax z2))

  (setq ssidx (1+ ssidx))
 )
 (list (list xmin ymin zmin) (list xmax ymax zmax))
)
;;Find file on OS env "PATH"
(defun acet-file-find-on-path ( fna path / pathlist entry retfile )
 (setq retfile NIL pathlist (acet-str-to-list ";" path))
 (while (and pathlist (not retfile))
  (setq entry (car pathlist) pathlist (cdr pathlist))
  (setq retfile (findfile (strcat entry fna)))
  (if (not retfile) (setq retfile (findfile (strcat entry "\\" fna))))
 )
 retfile
)
;;check for dotted pair
(defun acet-list-is-dotted-pair ( a / ret )
 (setq ret NIL)
 (if (and a (cdr a) (/= (type (cdr a)) 'LIST)) (setq ret T))
 ret
)
;;file open
(defun acet-file-open ( fna flag / ) (open fna flag))
;;remove duplicates from list
(defun acet-list-remove-duplicates ( lst fuz / retlist )
 (if (not fuz)
  (setq retlist (acet-list-remove-adjacent-dups lst))
  (setq retlist (acet-list-remove-duplicate-points lst fuz))
 )
)
;;Split List at entry
(defun acet-list-split ( lst item / retlist )
 (if (member item lst)
  (setq retlist lst)
  (setq retlist (list lst NIL))
 )
 retlist
)
;;Remove APPID
(defun acet-appid-delete ( appid / ) nil)
;;init progress bar
(defun acet-ui-progress-init ( title maxstep / ) (setq ET$ProgressActive (acet-ui-progress title maxstep)))
;;set progress pos
(defun acet-ui-progress-safe ( pos / ) (setq ET$ProgressActive (acet-ui-progress pos)))
;;done progress
(defun acet-ui-progress-done ( / ) (if ET$ProgressActive (setq ET$ProgressActive (acet-ui-progress))) NIL)
;;get long keyboard input
(defun acet-ui-get-long-name ( msg / ) (getstring T msg))
;;;============== END VOL 1-9 ================

;;========= internal Tool Functions =========
(defun acet::getltexmsg ( msgkey defmsg / msg )
 (setq msg defmsg)
 (if ltex$get_message (setq msg (ltex$get_message msgkey)))
 (if (and msg (/= (type msg) 'STR)) (setq msg ""))
 (if (and msg (<= (strlen msg) 0))  (setq msg ""))
 msg
)
;;Expand & Find Filename
(defun acet::expandfn ( fname fcheck / retfname ftype )
 (setq retfname NIL)
 (if fname
  (progn
   (setq ftype (acet::filetype fname))
   (if (not ftype) (setq fcheck T))
   (if fcheck        ;; with file checking
    (progn
     (setq retfname (findfile fname))
     (if (and (not retfname) ftype) (setq retfname (findfile (strcat fname ".des"))))
     (if (and (not retfname) ftype) (setq retfname (findfile (strcat fname ".lsp"))))
     (if (and (not retfname) ftype) (setq retfname (findfile (strcat fname ".arx"))))
     (if (and (not retfname) ftype) (setq retfname (findfile (strcat fname ".fas"))))
    )
    (setq retfname fname)
   )
  )
 )
 retfname
)
;;Get File Type Only
(defun acet::filetype ( filename / ftype ctr char1 found )
 (setq found NIL ftype "")
 (if filename
  (progn
   (setq ctr (strlen filename))
   (while (and (not found) (> ctr 0))
    (setq char1 (substr filename ctr 1))
    (if (or (= char1 "\\") (= char1 "/") (= char1 ".")) (setq found T))
    (setq ctr (1- ctr))
   )
   (setq ctr (+ ctr 1))
   (if (and found (= char1 ".")) (setq ftype (substr filename ctr)))
  )
 )
 ftype
)
;;Get Position of Extension
(defun acet::pos-filetype ( filename / ctr char1 index found )
 (setq index -1 found NIL char1 "")
 (if filename
  (progn
   (setq ctr (strlen filename))
   (while (and (not found) (> ctr 0))
    (setq char1 (substr filename ctr 1))
    (if (or (= char1 "\\") (= char1 "/") (= char1 ".")) (setq found T index ctr))
    (setq ctr (1- ctr))
   )
   (if (/= char1 ".") (setq index -1))
  )
 )
 index
)
;;Get File Without Path
(defun acet::nameonly ( filename / retfile ctr char1 found )
 (setq found NIL ctr (strlen filename) retfile filename)
 (while (and (not found) (> ctr 0))
  (setq char1 (substr retfile ctr 1))
  (if (or (= char1 "\\") (= char1 "/")) (setq found T))
  (setq ctr (1- ctr))
 )
 (setq ctr (1+ ctr) ctr (1+ ctr))
 (if found (setq retfile (substr retfile ctr)))
 retfile
)
;;Get Directory only
(defun acet::pathonly ( filename / fpath ctr char1 )
 (setq found NIL ctr (strlen filename) fpath "")
 (while (and (not found) (> ctr 0))
  (setq char1 (substr filename ctr 1))
  (if (or (= char1 "\\") (= char1 "/")) (setq found T))
  (setq ctr (1- ctr))
 )
 (setq ctr (1+ ctr))
 (if found (setq fpath (substr filename 1 ctr)))
 fpath
)

;;============================================
;;========== Run Cmd AutoLoader ==============
;;============================================

(cond
 ((< ET:InstalledVersion 0)  ;; valid ET file version for AC file version !
  (if (= ET:InstalledVersion -1) (prompt "\n* LTE 2000-2002 : wrong ExpressTools version found - load failed !"))
  (if (= ET:InstalledVersion -2) (prompt "\n* LTE 2004-2006 : wrong ExpressTools version found - load failed !"))
  (if (= ET:InstalledVersion -3) (prompt "\n* LTE 2007      : wrong ExpressTools version found - load failed !"))
  (if (= ET:InstalledFileVer  1) (prompt "\n*               : detected ExpressTools version is intended for Acad 2000-2002 !"))
  (if (= ET:InstalledFileVer  2) (prompt "\n*               : detected ExpressTools version is intended for Acad 2004-2006 !"))
  (if (= ET:InstalledFileVer  3) (prompt "\n*               : detected ExpressTools version is intended for Acad 2007 !"))
 )
 ((> ET:InstalledVersion 0)  ;; valid ET file version for AC file version !
  (LTEX$AutoLoadET)
  (cond
   ((<= g_AcadVer 15.99)
    (if (> (logand ET:InstalledVersion 1) 0) (prompt "\n* LTE 2000-2002 : ExpressTools Vol.1-8 Support - OK"))
    (if (> (logand ET:InstalledVersion 2) 0) (prompt "\n* LTE 2000-2002 : ExpressTools Vol.1-9 Support - OK"))
   )
   ((<= g_AcadVer 16.99)
    (if (> (logand ET:InstalledVersion 1) 0) (prompt "\n* LTE 2004-2006 : ExpressTools Vol.1-8 Support - OK"))
    (if (> (logand ET:InstalledVersion 2) 0) (prompt "\n* LTE 2004-2006 : ExpressTools Vol.1-9 Support - OK"))
   )
   ((<= g_AcadVer 17.99)
    (if (> (logand ET:InstalledVersion 1) 0) (prompt "\n* LTE 2007 : ExpressTools Vol.1-8 Support - OK"))
    (if (> (logand ET:InstalledVersion 2) 0) (prompt "\n* LTE 2007 : ExpressTools Vol.1-9 Support - OK"))
   )
  )
 )
)

(princ)

